package com.factory.controller.web;

import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.web.entity.statistics.ExceptionCountRes;
import com.factory.web.entity.statistics.StatisticsDateReq;
import com.factory.web.service.statistics.StatisticsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiOperationSupport;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 异常统计
 *
 * @author sMArT
 * @version 1.0
 * @date 2021-07-22 3:24 下午
 */
@Api(tags = "异常统计")
@RestController
@RequestMapping("/statistics/")
@Slf4j
public class WebStatisticsController {

    @Autowired
    private StatisticsService statisticsService;

    @ApiOperation(value = "当月异常统计")
    @ApiOperationSupport(order = 1)
    @PostMapping("/exceptions/month")
    public ResponseBean<ExceptionCountRes> countExceptionsByYear(@RequestBody StatisticsDateReq statisticsDateReq) {
        return statisticsService.getExceptionsByMonth(statisticsDateReq);
    }
//
//    @ApiOperation(value = "当日异常信息")
//    @ApiOperationSupport(order = 1)
//    @PostMapping("/exceptions/date/detail")
//    public ResponseBean exceptionsByMonth(@RequestBody AddPmPlanReq req) {
//        return ResponseBeanBuilder.ok();
//    }
}
