package com.factory.web.entity.excel;

import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFFont;

public class Utility {

    /**
     * 设置单元格样式
     *
     * @param wb
     * @param @isTitle
     * @return
     */
    public static XSSFCellStyle getTitleCellStyle(Workbook wb, short fontSize, HorizontalAlignment align) {
        XSSFCellStyle cellStyle = (XSSFCellStyle) wb.createCellStyle();
        XSSFFont font = (XSSFFont) wb.createFont();
        font.setFontHeightInPoints(fontSize);
        cellStyle.setFont(font);//选择需要用到的字体格式
        cellStyle.setWrapText(true);
        //设置边框:
        cellStyle.setBorderBottom(BorderStyle.THIN); //下边框
        cellStyle.setBorderLeft(BorderStyle.THIN);//左边框
        cellStyle.setBorderTop(BorderStyle.THIN);//上边框
        cellStyle.setBorderRight(BorderStyle.THIN);//右边框
        //设置居中:
        cellStyle.setAlignment(align); // 居中对齐
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);

        return cellStyle;
    }


    public static Sheet createSheet(Workbook wb, String name) {
        Sheet sheet = wb.createSheet(name);
        return sheet;
    }


    public static void addCellValForStr(Cell cell, String value, XSSFCellStyle style) {
        cell.setCellValue(value != null ? value : "");
        cell.setCellStyle(style);
    }


}
