package com.factory.web.entity.fa;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 任务审批
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("first_article_approval_task")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FirstArticleApprovalTask implements Serializable {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "任务审批id")
    private Long id;

    @ApiModelProperty(value = "任务id")
    private Long firstArticleTaskId;

    @ApiModelProperty(value = "角色ID")
    private Long approvalRole;

    @ApiModelProperty(value = "1质量工程师审批 2质量经理审批")
    private String approvalLevel;


    @ApiModelProperty(value = "审批人")
    private Long approvalUserId;

    @TableField(exist = false)
    @ApiModelProperty(value = "审批人")
    private String approvalUserName;

    @ApiModelProperty(value = "审批状态 0初始化 1放行 2不放行")
    private Integer status;

    @ApiModelProperty(value = "审批意见")
    private String reason;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "审批时间")
    private LocalDateTime updatedTime;

}
