package com.factory.web.entity.fa;

import java.io.Serializable;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.factory.base.util.time.TimeUtils;
import com.fasterxml.jackson.annotation.JsonAlias;
import com.fasterxml.jackson.annotation.JsonInclude;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 这个表日月周目前都只设置一个，目前对应useid也是一个本项目，但之后应该是
 * 每个人可以有一套信息的这个时间表是为了扩展和满足现有设计
 *
 * @author dl
 * @date 2021-08-06 17:51:58
 */
@Data
@TableName("first_article_calendar")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class FirstArticleCalendar implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)

    @ApiModelProperty(value = "唯一id主键")
    private Long id;

    @ApiModelProperty(value = "关联benteler_plan表的id")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "首件开始时间")
    private String firstStart;

    @ApiModelProperty(value = "首件提醒时间=首件开始时间+检验时长(分钟)")
    private String firstRemind;

    @ApiModelProperty(value = "首件（检测结束时间）")
    private String firstEnd;

    @JsonAlias("twoHundredSubmitTime")
    @ApiModelProperty(value = "200件提交时间（pad提醒时间）")
    private String twoRemind;

    @ApiModelProperty(value = "升级时长(分钟)")
    private Integer upleverTimeNum;

    @ApiModelProperty(value = "0:首件  1:200件  2:中断 判断该计划有几种类型")
    private String typeFlag;

    @ApiModelProperty(value = "责任人1班次")
    private String principalOneShift;

    @ApiModelProperty(value = "责任人1id")
    private Long principalOneId;

    @ApiModelProperty(value = "责任人2班次")
    private String principalTwoShift;

    @ApiModelProperty(value = "责任人2id")
    private Long principalTwoId;
    
    @ApiModelProperty(value = "责任人2id")
    @TableField(exist = false)
    private int firstCheck;
    
    public int getFirstCheck() {
    	int firstCheck = 0;
    	if(firstRemind!=null&&firstStart!=null) {
    		firstCheck = (int)java.time.Duration.between(TimeUtils.paserLocalTime(firstStart+":00"),TimeUtils.paserLocalTime(firstRemind+":00")).toMinutes();
    		if(firstCheck<0) {
    			firstCheck = (int)java.time.Duration.ofDays(1).toMinutes()+firstCheck;
    		}
    	}
    	return firstCheck;
    }
    public static void main(String[] args) {
    	String firstStart = "23:30";
    	String firstRemind = "00:00";
    	System.out.println(TimeUtils.paserLocalTime(firstStart+":00"));
    	System.out.println(TimeUtils.paserLocalTime(firstRemind+":00"));
    	int firstCheck = (int)java.time.Duration.between(TimeUtils.paserLocalTime(firstStart+":00"),TimeUtils.paserLocalTime(firstRemind+":00")).toMinutes();
		if(firstCheck<0) {
			firstCheck = (int)java.time.Duration.ofDays(1).toMinutes()+firstCheck;
		}
		System.out.println(firstCheck);
    	
    }
}
