package com.factory.web.entity.fa;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

/**
 * 巡检项目设置
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("first_article_item")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FirstArticleItem implements Serializable {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "巡检项目id")
    private Long id;

    @ApiModelProperty(value = "工作站id")
    private Long workshopId;
    @TableField(exist = false)
    @ApiModelProperty(value = "工作站名称")
    private String workshopName;

    @ApiModelProperty(value = "测量点描述")
    private String itemContent;

    @ApiModelProperty(value = "判断标准")
    private String itemStandard;

    @ApiModelProperty(value = "测量点前缀")
    private String prefix;

    @ApiModelProperty(value = "测量点序号开始")
    private Integer snoStart;

    @ApiModelProperty(value = "测量点序号结束")
    private Integer snoEnd;

    @ApiModelProperty(value = "数据类型 0数值 1属性")
    private Integer valFlag;

    @ApiModelProperty(value = "上限 对应数据类型0数值")
    private Double valUp;

    @ApiModelProperty(value = "下限 对应数据类型0数值")
    private Double valDown;

    @ApiModelProperty(value = "单位 对应数据类型0数值")
    private String valUnit;

    @ApiModelProperty(value = "0表示ok 1表示nook 对应数据类型1属性")
    private Integer valOk;

    @ApiModelProperty(value = "描述 对应数据类型1属性")
    private String valDesc;

    @ApiModelProperty(value = "特性等级")
    private String levelInfo;

    @ApiModelProperty(value = "产品特性")
    private String productInfo;

    @ApiModelProperty(value = "检验工具id")
    private String toolId;

    @ApiModelProperty(value = "检验工具描述")
    private String toolDesc;

    @ApiModelProperty(value = "检验频次首件 0没选择 1选择")
    private Integer firstFlag;

    @ApiModelProperty(value = "检验频次200件 0没选择 1选择")
    private Integer twoHundredFlag;

    @ApiModelProperty(value = "检验频次中断 0没选择 1选择")
    private Integer catchFlag;

    @TableField(exist = false)
    @ApiModelProperty(value = "首件检查结果")
    private List<FirstArticleItemResult> firstItemResultList; // 用于页面返回值

    @TableField(exist = false)
    @ApiModelProperty(value = "200件检查结果")
    private List<FirstArticleItemResult> twoHundredItemResultList; // 用于页面返回值

    @TableField(exist = false)
    @ApiModelProperty(value = "中断检查结果")
    private List<FirstArticleItemResult> catchItemResultList; // 用于页面返回值

    @TableField(exist = false)
    @ApiModelProperty(value = "是否有特殊情况的首件放行记录 0没有 1有")
    private Integer releaseFlag;

    @TableField(exist = false)
    @ApiModelProperty(value = "放行记录备注叠加")
    private List<FirstArticleApprovalTask> permitDesc;

    @TableField(exist = false)
    @ApiModelProperty(value = "任务信息-小程序用")
    private FirstArticleTask firstArticleTask;
    @TableField(exist = false)
    @ApiModelProperty(value = "所属task状态-小程序用")
    private int firstArticleApprovalTaskStatus;
}
