package com.factory.web.entity.fa;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 任务点检结果
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("first_article_item_result")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FirstArticleItemResult implements Serializable {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "检查结果id")
    private Long id;

    @ApiModelProperty(value = "任务id")
    private Long firstArticleTaskId;

    @ApiModelProperty(value = "巡检项目id")
    private Long firstArticleItemId;

    @ApiModelProperty(value = "对应数据类型0数值")
    private String val;

    @ApiModelProperty(value = "对应数据类型1属性")
    private String valDesc;

    @ApiModelProperty(value = "0通过 1巡检不通过 2没有巡检")
    private Integer result;

    @ApiModelProperty(value = "task整体提交时，备份result字段的值。 0通过 1巡检不通过 2没有巡检")
    private Integer resultBak;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建人")
    private Long createdUserId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;

    @ApiModelProperty(value = "测量点前缀")
    private String prefix;

    @ApiModelProperty(value = "测量点序号")
    private Integer sno;

    @ApiModelProperty(value = "工具")
    private String toolDesc;

    @ApiModelProperty(value = "异常信息")
    private String abnormal;

    @ApiModelProperty(value = "订单号")
    private String orderNumber;

    @TableField(exist = false)
    @ApiModelProperty(value = "所属task状态-小程序用")
    private int firstArticleApprovalTaskStatus;
}
