package com.factory.web.entity.fa;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 任务
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("first_article_task")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FirstArticleTask implements Serializable {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "任务id")
    private Long id;

    @ApiModelProperty(value = "巡检时间表id")
    private Long firstArticleCalendarId;

    @ApiModelProperty(value = "0初始化 1待审核状态 2放行 3不通过 4通过")
    private Integer status;

    @ApiModelProperty(value = "任务创建时间")
    private LocalDate taskTime;

    @ApiModelProperty(value = "是否发送了任务提醒给操作者 0没提醒 1已提醒")
    private Integer remindTaskFlag;

    @ApiModelProperty(value = "没工作提醒是不是已经完成 0没提醒 1已提醒")
    private Integer remindNoworkFlag;

    @ApiModelProperty(value = "首件类型 0首件 1：200件 2中断")
    private Integer typeFlag;

    @ApiModelProperty(value = "点检人")
    private Long submitUserId;

    @ApiModelProperty(value = "点检时间")
    private LocalDateTime submitTime;

    @TableField(exist = false)
    @ApiModelProperty(value = "任务审批信息")
    private List<FirstArticleApprovalTask> firstArticleApprovalTasks;

}
