package com.factory.web.entity.fa;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 任务和巡检结果历史
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("first_article_task_his_blob")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FirstArticleTaskHisBlob implements Serializable {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "历史id")
    private Long id;

    @ApiModelProperty(value = "任务id")
    private Long firstArticleTaskId;

    @ApiModelProperty(value = "计划历史内容")
    private byte[] hisContent;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建人")
    private Long createdUserId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;
}