package com.factory.web.entity.fa.req;

import com.factory.web.entity.fa.FirstArticleTitle;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.validation.annotation.Validated;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.time.LocalDate;
import java.util.List;

/**
 * 新建防错计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class AddFaPlanReq {

    @Size(max = 128, message = "名字长度过长")
    @NotEmpty(message = "计划名称不能为空")
    @ApiModelProperty(value = "计划名称", example = "计划A")
    private String bentelerPlanName;

    @ApiModelProperty(value = "生效日期", example = "2021-06-06")
    private LocalDate effectiveDate;

    @ApiModelProperty(value = "责任人1班次")
    private String principalOneShift;

    @ApiModelProperty(value = "责任人1  id")
    private Long principalOneId;

    @ApiModelProperty(value = "责任人2班次")
    private String principalTwoShift;

    @ApiModelProperty(value = "责任人2id")
    private Long principalTwoId;
    @NotEmpty(message = "首件开始时间不能为空")
    @ApiModelProperty(value = "首件开始时间")
    private String firstStart;

    @NotEmpty(message = "首件结束时间不能为空")
    @ApiModelProperty(value = "首件结束时间")
    private String firstEnd;
    @NotNull(message = "检验时长不能为空")
    @ApiModelProperty(value = "检验时长(分钟)")
    private Integer firstCheck;

    @NotNull(message = "升级时间不能为空")
    @ApiModelProperty(value = "升级时间(分钟)")
    private Integer firstUpdate;
    @NotEmpty(message = "200件最晚提交时间不能为空")
    @ApiModelProperty(value = "200件最晚提交时间")
    private String twoHundredSubmitTime;

    @ApiModelProperty(value = "首件、200件、中断类型")
    private String typeFlag;

    @ApiModelProperty(value = "表头信息")
    private FirstArticleTitle firstArticleTitle;

    @ApiModelProperty(value = "指导文件")
    private Long url;

    @ApiModelProperty(value = "工作站及巡检内容")
    private List<FirstArticleWorkshopReq> firstArticleWorkshopList;
}
