package com.factory.web.entity.fa.req;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 巡检项目设置
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FirstArticleItemReq {

    @ApiModelProperty(value = "测量点描述")
    private String itemContent;

    @ApiModelProperty(value = "判断标准")
    private String itemStandard;

    @ApiModelProperty(value = "测量点前缀")
    private String prefix;

    @ApiModelProperty(value = "测量点序号开始")
    private Integer snoStart;

    @ApiModelProperty(value = "测量点序号结束")
    private Integer snoEnd;

    @ApiModelProperty(value = "数据类型 0数值 1属性")
    private Integer valFlag;

    @ApiModelProperty(value = "上限 对应数据类型0数值")
    private Double valUp;

    @ApiModelProperty(value = "下限 对应数据类型0数值")
    private Double valDown;

    @ApiModelProperty(value = "单位 对应数据类型0数值")
    private String valUnit;

    @ApiModelProperty(value = "0表示ok 1表示nook 对应数据类型1属性")
    private Integer valOk;

    @ApiModelProperty(value = "描述 对应数据类型1属性")
    private String valDesc;

    @ApiModelProperty(value = "特性等级")
    private String levelInfo;

    @ApiModelProperty(value = "产品特性")
    private String productInfo;

    @ApiModelProperty(value = "检验工具id")
    private String toolId;

    @ApiModelProperty(value = "检验工具描述")
    private String toolDesc;

    @ApiModelProperty(value = "检验频次首件 0没选择 1选择")
    private Integer firstFlag;

    @ApiModelProperty(value = "检验频次200件 0没选择 1选择")
    private Integer twoHundredFlag;

    @ApiModelProperty(value = "检验频次中断 0没选择 1选择")
    private Integer catchFlag;
}
