package com.factory.web.entity.fa.req;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 首件计划，Pad端点检人员可见的计划列表
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class SearchFaPlanListForPadReq {

    @ApiModelProperty(value = "Pad端登录的检查人员用户Id")
    private Long userId;

    @ApiModelProperty(value = "0未完成 1已完成 2待重检")
    private Integer type;

    @ApiModelProperty(value = "0表示首件 1表示200件")
    private Integer typeFlag;
}
