package com.factory.web.entity.fa.req;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 取得Pad端首件计划对应的工作站
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class SearchFaWorkshopListForPadReq {

    @ApiModelProperty(value = "计划Id")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "0表示首件 1表示200件 2表示中断")
    private Integer typeFlag;

    @ApiModelProperty(value = "点检人对应的用户ID")
    private Long userId;
    
    @ApiModelProperty(value = "0初始化 1待审核状态 2放行 3不通过 4通过",hidden = true)
    private Integer status;

    @ApiModelProperty(value = "中断任务ID可为空,为空获取最新未完成或新建一个")
    private Long taskId;
    
//	@ApiModelProperty(value = "工作站Id")
//	private Long workshopId;
}
