package com.factory.web.entity.fa.res;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * 首件计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class FaCalendarRes implements Serializable {

    @ApiModelProperty(value = "0表示首件 1表示200件 2表示中断")
    private Integer typeFlag;

    @ApiModelProperty(value = "检验时间")
    private LocalDateTime taskTime;

    @ApiModelProperty(value = "检验人")
    private String checkPerson;

}
