package com.factory.web.entity.fa.res;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 取得不放行任务对应的审批人、审批意见、审批时间
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class FaNoGoTaskAapprovalRes implements Serializable {

    @ApiModelProperty(value = "质量经理用户id")
    private Long approvalUserId;

    @ApiModelProperty(value = "质量经理")
    private String approvalPerson;

    @ApiModelProperty(value = "评审意见")
    private String reason;

    @ApiModelProperty(value = "审批时间")
    private LocalDateTime approvalTime;

}
