package com.factory.web.entity.fa.res;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * 首件计划，Pad端点检人员可见的计划列表
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class FaPlanListForPadRes implements Serializable {

    @ApiModelProperty(value = "任务ID")
    private Long firstArticleTaskId;

    @ApiModelProperty(value = "任务状态 0初始化 1待审核状态 2放行 3不通过 4通过")
    private Integer status;

    @ApiModelProperty(value = "计划ID")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "计划名称")
    private String bentelerPlanName;

    @ApiModelProperty(value = "规则id")
    private Long firstArticleCalendarId;

    @ApiModelProperty(value = "0表示首件 1表示200件 2表示中断")
    private Integer typeFlag;

}
