package com.factory.web.entity.fa.res;

import com.factory.web.entity.fa.FirstArticleCalendar;
import com.factory.web.entity.fa.FirstArticleTitle;
import com.factory.web.entity.fa.FirstArticleWorkshop;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDate;
import java.util.List;

/**
 * 首件计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class FaPlanRes implements Serializable {

    @ApiModelProperty(value = "计划ID")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "计划名称")
    private String bentelerPlanName;

    @ApiModelProperty(value = "计划类型 1首件 2防错")
    private Integer planType;

    @ApiModelProperty(value = "生效日期", example = "2021-06-06")
    private LocalDate effectiveDate;

    @ApiModelProperty(value = "日周月点检规则")
    private List<FirstArticleCalendar> firstArticleCalendarList;

    @ApiModelProperty(value = "表头信息")
    private FirstArticleTitle firstArticleTitle;

    @ApiModelProperty(value = "工作站及巡检内容")
    private List<FirstArticleWorkshop> firstArticleWorkshopList;

//	@ApiModelProperty(value = "文件信息")
//	private FileEntry fileEntry;

    @ApiModelProperty(value = "文件名")
    private String fileNm;

    @ApiModelProperty(value = "文件id")
    private Integer url;

}
