package com.factory.web.entity.fa.res;

import com.factory.web.entity.fa.FirstArticleItemResult;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDate;
import java.util.List;

/**
 * 首件任务
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class FaTaskRes implements Serializable {

    @ApiModelProperty(value = "任务id")
    private Long firstArticleTaskId;

    @ApiModelProperty(value = "巡检时间表id")
    private Long firstArticleCalendarId;

    @ApiModelProperty(value = "0初始化 1待审核状态 2放行 3不通过 4通过")
    private Integer status;
    
    @ApiModelProperty(value = "任务类型")
    private Integer typeFlag;

    @ApiModelProperty(value = "任务创建时间")
    private LocalDate taskTime;

    @ApiModelProperty(value = "是否发送了任务提醒给操作者 0没提醒 1已提醒")
    private Integer remindTaskFlag;

    @ApiModelProperty(value = "没工作提醒是不是已经完成 0没提醒 1已提醒")
    private Integer remindNoworkFlag;

    @ApiModelProperty(value = "巡检项目检查结果")
    private List<FirstArticleItemResult> firstArticleItemResultList;

}
