package com.factory.web.entity.fa.res;

import java.io.Serializable;
import java.time.LocalDate;

import com.fasterxml.jackson.annotation.JsonInclude;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 首件任务
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("Pad中断任务列表")
public class FaTaskResForPad implements Serializable {

    @ApiModelProperty(value = "任务id")
    private Long firstArticleTaskId;

    @ApiModelProperty(value = "巡检时间表id")
    private Long firstArticleCalendarId;

    @ApiModelProperty(value = "0初始化 1待审核状态 2放行 3不通过 4通过")
    private Integer status;
    
    @ApiModelProperty(value = "任务类型0首件 1二百 2中断")
    private Integer typeFlag;

    @ApiModelProperty(value = "任务创建时间")
    private LocalDate taskTime;

}
