package com.factory.web.entity.onsite;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 巡检项目设置
 *
 * @author wzy
 * @date 2021-07-06 12:10:10
 */
@Data
@TableName("onsite_item")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class OnsiteItem2 {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "巡检项目id")
    private Long id;

    @ApiModelProperty(value = "关联在工作站id")
    private Long workshopId;

    @ApiModelProperty(value = "巡检项目内容设置")
    private String itemContent;

    @ApiModelProperty(value = "0日巡检  1周巡检  2月巡检")
    private Integer typeFlag;

    @ApiModelProperty(value = "0非手动 1手动")
    private Integer inspectionFlag;
}
