package com.factory.web.entity.onsite;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.Min;

/**
 * 巡检项目设置
 *
 * @author wzy
 * @date 2021-07-06 12:10:10
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class OnsiteItemReq {

    @ApiModelProperty(value = "唯一id主键", example = "1")
    private Long id;

    @ApiModelProperty(value = "关联在工作站id", example = "111111")
    private Long workshopId;

    @ApiModelProperty(value = "巡检项目内容设置", example = "检查车身情况")
    private String itemContent;

    @ApiModelProperty(value = "0日巡检  1周巡检  2月巡检", example = "1")
    private Integer typeFlag;

    @ApiModelProperty(value = "0非手动 1手动", example = "1")
    private Integer inspectionFlag;

    @ApiModelProperty(value = "页码", example = "1")
    @Min(value = 1, message = "页数最小值不能小于1")
    private int page = 1;

    @ApiModelProperty(value = "每页数据大小", example = "10")
    @Min(value = 1, message = "记录数不能小于1")
    private int size = 99999;
}
