package com.factory.web.entity.pm;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 审批规则
 *
 * @author sMArT
 * @version 1.0
 * @date 2021-07-15 4:50 下午
 */
@Data
@TableName("approval_rule")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ApprovalRule {
	/**
     * 审批规则类型为：1新建计划审批
     */
    public final static int APPROVAL_TYPE_NEW = 1;
    /**
     * 审批规则类型为：2首件审批
     */
    public final static int APPROVAL_TYPE_FA = 2;
    /**
     * 审批规则类型为：3防错放行审批
     */
    public final static int APPROVAL_TYPE_PM = 3;
    
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "计划审批规则id")
    private Long id;
    @ApiModelProperty(value = "审批级别")
    private int approvalLevel;
    @ApiModelProperty(value = "角色id")
    private Long roleId;
    @ApiModelProperty(value = "审批类型 1新建计划审批  2首件审批  3防错审批")
    private int type;
}
