package com.factory.web.entity.pm;

import java.io.Serializable;
import java.time.LocalDateTime;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 计划审批
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("onsite_approval_plan")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class OnsiteApprovalPlan implements Serializable {
	@TableId(type = IdType.AUTO)
	@ApiModelProperty(value = "计划审批id")
	private Long id;
	
	@ApiModelProperty(value = "计划id")
	private Long bentelerPlanId;

	@ApiModelProperty(value = "角色ID")
	private Long approvalRole;

	@ApiModelProperty(value = "1质量经理审批 2生产经理审批")
	private Integer approvalLevel;

	@ApiModelProperty(value = "审批人:操作的人")
	private Long approvalUserId;

	@ApiModelProperty(value = "审批人姓名")
	@TableField(exist = false)
	private String approvalPerson;

	@ApiModelProperty(value = "审批状态 0未审批 1审批通过 2驳回")
	private Integer status;

	@ApiModelProperty(value = "审批意见")
	private String reason;

	@TableField(fill = FieldFill.INSERT)

	@ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "审批时间")
    private LocalDateTime updatedTime;

}
