package com.factory.web.entity.pm;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * 日周月点检规则
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("onsite_calendar")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class OnsiteCalendar implements Serializable {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "规则id")
    private Long id;

    @ApiModelProperty(value = "计划id")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "日巡检开始时间 格式11:00")
    private String startDay;

    @ApiModelProperty(value = "日巡检结束时间 格式11:00")
    private String endDay;

    @ApiModelProperty(value = "日检查时长设置单位分钟 例如60")
    private Integer dayValidate;

    @ApiModelProperty(value = "升级时长设置单位是分钟 例如60 这个时间其实是汇报超时给监督")
    private Integer dayOuttime;

    @ApiModelProperty(value = "周巡检时间设置  1-7")
    private Integer weekDay;

    @ApiModelProperty(value = "月巡检时间 1-28")
    private Integer monthDay;

    @ApiModelProperty(value = "月巡检备用预留字段")
    private Integer month;

    @ApiModelProperty(value = "点检人对应的用户ID")
    private Long userId;

    @ApiModelProperty(value = "0日巡检  1周巡检  2月巡检")
    private Integer typeFlag;

    @ApiModelProperty(value = "班次")
    private String shift;
    
    @ApiModelProperty(value = "是否有效:有对应检查项：1无0")
    private Boolean effectFlag;

}
