package com.factory.web.entity.pm;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * 巡检项目设置
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("onsite_item")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class OnsiteItem implements Serializable {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "巡检项目id")
    private Long id;

    @ApiModelProperty(value = "工作站id")
    private Long workshopId;

    @ApiModelProperty(value = "巡检项目内容")
    private String itemContent;

    @ApiModelProperty(value = "0日巡检  1周巡检  2月巡检")
    private Integer typeFlag;

    @ApiModelProperty(value = "0非手动 1手动")
    private Integer inspectionFlag;

    @TableField(exist = false)
    @ApiModelProperty(value = "0通过 1巡检不通过 2没有巡检")
    private Integer result;

    @TableField(exist = false)
    @ApiModelProperty(value = "异常信息")
    private String abnormal;

}
