package com.factory.web.entity.pm;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 任务点检结果
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("onsite_item_result")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class OnsiteItemResult implements Serializable {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "检查结果id")
    private Long id;

    @ApiModelProperty(value = "任务id")
    private Long onsiteTaskId;

    @ApiModelProperty(value = "巡检项目id")
    private Long onsiteItemId;

    @ApiModelProperty(value = "0通过 1巡检不通过 2没有巡检")
    private Integer result;

    @ApiModelProperty(value = "task整体提交时，备份result字段的值。 0通过 1巡检不通过 2没有巡检")
    private Integer resultBak;

    @ApiModelProperty(value = "异常信息")
    private String abnormal;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建人")
    private Long createdUserId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createdTime;

}
