package com.factory.web.entity.pm;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

/**
 * 工作站
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@TableName("onsite_workshop")
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class OnsiteWorkshop implements Serializable {

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "工作站id")
    private Long id;

    @ApiModelProperty(value = "计划id")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "工作站名称")
    private String wsName;

    @TableField(exist = false)
    @ApiModelProperty(value = "日周月点检规则")
    private List<OnsiteItem> onsiteItemList; // 用于页面返回值

    @TableField(exist = false)
    @ApiModelProperty(value = "0没完成 1全部完成")
    private Integer allCheckFlag;

}
