package com.factory.web.entity.pm.req;

import com.factory.web.entity.pm.OnsiteTitle;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Size;
import java.time.LocalDate;
import java.util.List;

/**
 * 新建防错计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class AddPmPlanReq {

    @Size(max = 128, message = "名字长度过长")
    @NotEmpty(message = "计划名称不能为空")
    @ApiModelProperty(value = "计划名称", example = "计划A")
    private String bentelerPlanName;

    @ApiModelProperty(value = "生效日期", example = "2021-06-06")
    private LocalDate effectiveDate;

    @ApiModelProperty(value = "日周月点检规则")
    private List<OnsiteCalendarReq> onsiteCalendarList;

    @ApiModelProperty(value = "表头信息")
    private OnsiteTitle onsiteTitle;

    @ApiModelProperty(value = "工作站及巡检内容")
    private List<OnsiteWorkshopReq> onsiteWorkshopList;
}
