package com.factory.web.entity.pm.req;

import java.time.LocalDate;

import com.fasterxml.jackson.annotation.JsonInclude;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 工作站
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class SearchAbnormalReq {

    @ApiModelProperty(value = "年月日", example = "2021-06-08")
    private LocalDate checkDate;

    @ApiModelProperty(value = "工作站id")
    private Long workshopId;

    @ApiModelProperty(value = "任务id")
    private Long taskId;

    @ApiModelProperty(value = "巡检项目id")
    private Long itemId;

    @ApiModelProperty(value = "0表示首件 1表示200件 2表示中断")
    private Integer typeFlag;

}
