package com.factory.web.entity.pm.req;

import java.time.LocalDateTime;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 检查记录
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class SearchCheckRecordReq {

    @ApiModelProperty(value = "点检频次")
    private Integer typeFlag;

    @ApiModelProperty(value = "年月", example = "2021-06")
    private String yearMonth;

    @ApiModelProperty(value = "巡检项目id")
    private Long onsiteItemId;
    
    
    @ApiModelProperty(value = "开始时间",hidden = true)
    private LocalDateTime sdate;
    @ApiModelProperty(value = "结束时间",hidden = true)
    private LocalDateTime edate;


}
