package com.factory.web.entity.pm.req;

import java.time.LocalDateTime;

import com.fasterxml.jackson.annotation.JsonInclude;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 防错计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class SearchPmPlanReq {

    @ApiModelProperty(value = "计划Id")
    private Long bentelerPlanId;
    
    @ApiModelProperty(value = "计划时间范围内任务yyyy-MM")
    private String yearMonth;
    
    @ApiModelProperty(value = "开始时间",hidden = true)
    private LocalDateTime sdate;
    @ApiModelProperty(value = "结束时间",hidden = true)
    private LocalDateTime edate;

}
