package com.factory.web.entity.pm.res;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 防错计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class AbnormalTaskInfoRes implements Serializable {

    @ApiModelProperty(value = "计划Id")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "计划名称")
    private String bentelerPlanName;

    @ApiModelProperty(value = "计划类型 1首件 2防错")
    private Integer planType;

    @ApiModelProperty(value = "1质量工程师审批 2质量经理审批")
    private Integer approvalLevel;

    @ApiModelProperty(value = "放行：操作人；重检：操作人")
    private String person;

    @ApiModelProperty(value = "1放行 2重检")
    private Integer method;

    @ApiModelProperty(value = "审批意见")
    private String reason;

    @ApiModelProperty(value = "审批时间")
    private LocalDateTime updatedTime;

    @ApiModelProperty(value = "0初始化 1待审核状态 2放行 3不通过 4通过")
    private Integer status;

    @ApiModelProperty(value = "首件：0表示首件 1表示200件 2表示中断；防错：0日巡检  1周巡检  2月巡检")
    private Integer typeFlag;

    @ApiModelProperty(value = "任务id")
    private Long taskId;
    
    @ApiModelProperty(value = "工作站")
    private List<AbnormalWorkshopRes> abnormalWorkshopList;

    @ApiModelProperty(value = "任务审批记录-小程序")
    private List<AbnormalApprovalTaskRes> abnormalApprovalTaskResList;

}
