package com.factory.web.entity.pm.res;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 每频次点检信息
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class PmCheckListRes implements Serializable {

    @ApiModelProperty(value = "计划ID")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "巡检时间表id")
    private Long onsiteCalendarId;

    @ApiModelProperty(value = "0日巡检  1周巡检  2月巡检")
    private Integer typeFlag;

    @ApiModelProperty(value = "检查人")
    private String checkPerson;

    @ApiModelProperty(value = "任务id")
    private Long onsiteTaskId;

    @ApiModelProperty(value = "检验时间")
    private LocalDateTime checkTime;

}
