package com.factory.web.entity.pm.res;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

/**
 * 检查记录
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class PmCheckRecordItemListRes implements Serializable {

    @ApiModelProperty(value = "巡检项目id")
    private Long onsiteItemId;

    @ApiModelProperty(value = "巡检项目内容")
    private String itemContent;
    
    @ApiModelProperty(value = "0日巡检  1周巡检  2月巡检")
    private Integer typeFlag;


    @ApiModelProperty(value = "一个月内的点检记录")
    private List<PmCheckRecordRes> checkRecordList;

}
