package com.factory.web.entity.pm.res;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * 防错计划，Pad端点检人员可见的计划列表
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class PmPlanListForPadRes implements Serializable {

    @ApiModelProperty(value = "任务ID")
    private Long onsiteTaskId;

    @ApiModelProperty(value = "任务状态 0初始化 1待审核状态 2放行 3不通过 4通过")
    private Integer status;

    @ApiModelProperty(value = "计划ID")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "计划名称")
    private String bentelerPlanName;

    @ApiModelProperty(value = "规则id")
    private Long onsiteCalendarId;

    @ApiModelProperty(value = "0日巡检  1周巡检  2月巡检")
    private Integer typeFlag;

}
