package com.factory.web.entity.pm.res;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 防错计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class PmPlanListRes implements Serializable {

    @ApiModelProperty(value = "计划ID")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "计划名称")
    private String bentelerPlanName;

    @ApiModelProperty(value = "计划类型 1首件 2防错")
    private Integer planType;

    @ApiModelProperty(value = "计划状态 0未完成 1已完成 2待重检")
    private Integer planStatus;

    @ApiModelProperty(value = "计划创建日期")
    private LocalDateTime createdTime;

    @ApiModelProperty(value = "0解禁、1禁用")
    private Integer pauseFlag;

    @ApiModelProperty(value = "1质量经理审批 2生产经理审批")
    private Integer approvalLevel;

    @ApiModelProperty(value = "审批人id")
    private Long approvalUserId;

    @ApiModelProperty(value = "审批人姓名")
    private String approvalPerson;

    @ApiModelProperty(value = "审批状态 0未审批 1审批通过 2驳回")
    private Integer status;

    @ApiModelProperty(value = "审批意见")
    private String reason;

    @ApiModelProperty(value = "审批时间")
    private LocalDateTime updatedTime;

}
