package com.factory.web.entity.pm.res;

import com.factory.web.entity.pm.OnsiteCalendar;
import com.factory.web.entity.pm.OnsiteTitle;
import com.factory.web.entity.pm.OnsiteWorkshop;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDate;
import java.util.List;

/**
 * 防错计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class PmPlanRes implements Serializable {

    @ApiModelProperty(value = "计划ID")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "计划名称")
    private String bentelerPlanName;

    @ApiModelProperty(value = "计划类型 1首件 2防错")
    private Integer planType;

    @ApiModelProperty(value = "生效日期", example = "2021-06-06")
    private LocalDate effectiveDate;

    @ApiModelProperty(value = "日周月点检规则")
    private List<OnsiteCalendar> onsiteCalendarList;

    @ApiModelProperty(value = "创建人")
    private Long createdUserId;

    @ApiModelProperty(value = "表头信息")
    private OnsiteTitle onsiteTitle;
    
    @ApiModelProperty(value = "上一个版本", example = "2021-06-06",hidden = true)
    private LocalDate prevEffectiveDate;
    
    @ApiModelProperty(value = "上一个版本ID",hidden = true)
    private Long prevPlanId;

    @ApiModelProperty(value = "工作站及巡检内容")
    private List<OnsiteWorkshop> onsiteWorkshopList;

//	@ApiModelProperty(value = "文件信息")
//	private FileEntry fileEntry;

    @ApiModelProperty(value = "文件名")
    private String fileNm;

}
