package com.factory.web.entity.vo.req.web;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

/**
 * @program: intelligentfactory
 * @description:
 * @author: dl
 * @create: 06月29日 12时
 **/
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class AddIniPlanItemReq {

    @ApiModelProperty(value = "频率1首件 2两百 3中断 包括哪项", example = "[1,2]")
    private List<Integer> checkType;
    //
    @ApiModelProperty(value = "测量点描述", example = "测量点描述")
    private String measuRemark;

    @ApiModelProperty(value = "判断标准", example = "判断标准")
    private String method;

    @ApiModelProperty(value = "检测标准值上限", example = "10")
    private BigDecimal checkStandardTop;

    @ApiModelProperty(value = "检测标准值下限", example = "15")
    private BigDecimal checkStandardFloor;

    @ApiModelProperty(value = "工位前缀", example = "S")
    private String workPrefix;

    @ApiModelProperty(value = "检验测量点首号", example = "1")
    private Integer workStationBegin;

    @ApiModelProperty(value = "检验测量点尾号", example = "5")
    private Integer workStationEnd;

    @ApiModelProperty(value = "频次1日2周3月4季度5半年6班", example = "1")
    private Integer frequency;

    @ApiModelProperty(value = "频次检测点 第(5)天 星期(3)", example = "2")
    private Integer frequencyNo;

    @ApiModelProperty(value = "数据类别", example = "1")
    private Integer dataType;

    @ApiModelProperty(value = "特性等级", example = "特性等级")
    private String level;

    @ApiModelProperty(value = "单位", example = "单位")
    private String unit;

    @ApiModelProperty(value = "校验工具", example = "1")
    private Integer tool;

    @ApiModelProperty(value = "校验工具 具体描述", example = "校验工具具体描述")
    private String toolRemark;


    @ApiModelProperty(value = "特性", example = "特性")
    private String inspectionItem;

}
