package com.factory.web.entity.vo.res.web.ini;

import com.factory.base.config.validateGroup.GroupOne;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Size;

/**
 * @program: intelligent-factory-service
 * @description:
 * @author: dl
 * @create: 05月13日 12时
 **/
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class GetVersionBaseRes {

    @Size(max = 20, message = "项目名称长度过长", groups = GroupOne.class)
    @NotEmpty(message = "项目名称不能为空", groups = GroupOne.class)
    @ApiModelProperty(value = "项目名称", example = "计划名称")
    private String project;

    @Size(max = 20, message = "零件长度过长", groups = GroupOne.class)
    @NotEmpty(message = "零件不能为空", groups = GroupOne.class)
    @ApiModelProperty(value = "零件名称", example = "计划名称")
    private String part;

    @Size(max = 20, message = "本特勒零件号长度过长", groups = GroupOne.class)
    @NotEmpty(message = "本特勒零件号不能为空", groups = GroupOne.class)
    @ApiModelProperty(value = "本特勒零件号", example = "计划名称")
    private String btlPartNo;

    @Size(max = 20, message = "客户零件号长度过长", groups = GroupOne.class)
    @NotEmpty(message = "客户零件号不能为空", groups = GroupOne.class)
    @ApiModelProperty(value = "客户零件号", example = "计划名称")
    private String clientPartNo;

    @Size(max = 20, message = "客户零件号长度过长", groups = GroupOne.class)
    @NotEmpty(message = "客户零件号不能为空", groups = GroupOne.class)
    @ApiModelProperty(value = "客户零件号", example = "计划名称")
    private String verson;

    @Size(max = 20, message = "Dmba长度过长", groups = GroupOne.class)
    @NotEmpty(message = "Dmba不能为空", groups = GroupOne.class)
    @ApiModelProperty(value = "Dmba", example = "计划名称")
    private String Dmba;
}
