package com.factory.web.entity.vo.res.web.ini;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

/**
 * @program: intelligentfactory
 * @description:
 * @author: dl
 * @create: 06月29日 15时
 **/
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
@ApiModel("")
public class getCheckResutGreadRes {


    @ApiModelProperty(value = "特性")
    private String inspectionItem;


    @ApiModelProperty(value = "判断标准方法")
    private String method;
    @ApiModelProperty(value = "检测标准值上限")
    private BigDecimal checkStandardTop;
    @ApiModelProperty(value = "检测标准值下限")
    private BigDecimal checkStandardFloor;

    @TableField(exist = false)
    @ApiModelProperty(value = "频率1首件 2两百 3中断 包括哪项")
    private List<Long> checkTypeList;
    @ApiModelProperty(value = "频率1首件 2两百 3中断 包括哪项")
    private String checkType;


    @ApiModelProperty(value = "特性等级")
    private String level;

    @ApiModelProperty(value = "工作站")
    private String workstation;
    @ApiModelProperty(value = "工作站id")
    private String workstationId;


    @ApiModelProperty(value = "首件订单号", hidden = true)
    private String orderId;

    @ApiModelProperty(value = "首件订单号")
    private String iniOrderId;
    @ApiModelProperty(value = "两百订单号")
    private String twoOrderId;
    @ApiModelProperty(value = "中断订单号")
    private String breakOrderId;


    @ApiModelProperty(value = "工位前缀")
    private String workPrefix;
    @ApiModelProperty(value = "检验测量点首号")
    private Integer workStationBegin;
    @ApiModelProperty(value = "检验测量点尾号")
    private Integer workStationEnd;


    @ApiModelProperty(value = "审核结果json")
    private String iniGread;
    @ApiModelProperty(value = "审核结果json")
    private String twoGread;
    @ApiModelProperty(value = "审核结果json")
    private String breakGread;


    @ApiModelProperty(value = "校验工具")
    private Integer tool;
    @ApiModelProperty(value = "校验工具 具体描述")
    private String toolRemark;

    @ApiModelProperty(value = "特殊情况首件放行记录")
    private String discharged;


}
