package com.factory.web.mapper.ini;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.factory.base.entity.po.benteler.BentelerIniCheckItem;
import com.factory.base.entity.po.benteler.BentelerIniVersion;
import com.factory.base.entity.po.benteler.BentelerIniVersionItem;
import com.factory.base.entity.po.benteler.BentelerIniWorkstation;
import com.factory.web.entity.vo.req.pad.GetVersionCheckItemReq;
import com.factory.web.entity.vo.req.web.PlanListReq;
import com.factory.web.entity.vo.res.pad.ini.getNowCheckStatusRes;
import com.factory.web.entity.vo.res.web.ini.PagePlanRes;
import com.factory.web.entity.vo.res.web.ini.getCheckResutGreadRes;
import com.factory.web.entity.vo.res.web.ini.unAuditListRes;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDate;
import java.util.List;

/**
 * 计划 - 版本信息
 *
 * @author chenshun
 * @email sunlightcs@gmail.com
 * @date 2021-06-26 12:35:17
 */
@Mapper
public interface BentelerIniVersionMapper extends BaseMapper<BentelerIniVersion> {

    Page<PagePlanRes> pagePlan(@Param("page") Page<PagePlanRes> page,
                               @Param("name") String name,
                               @Param("checkStatus") Integer checkStatus);


    List<PagePlanRes> Planlist(@Param("page") Page<PagePlanRes> page,
                               @Param("name") String name,
                               @Param("checkStatus") Integer checkStatus,
                               @Param("VersionId") Long VersionId);

    Page<unAuditListRes> unAuditList(@Param("page") Page page, @Param("req") PlanListReq req);


    BentelerIniVersion getPlan_CurrentVersion(@Param("planId") Long planId);

    BentelerIniVersion getPlan_UnAuditVersion(@Param("planId") Long planId);

    BentelerIniVersion getPlan_WaitAuditVersion(@Param("planId") Long planId);


    BentelerIniVersionItem getVersion_Item(@Param("versionId") Long versionId);

    List<BentelerIniWorkstation> getVersion_Works(@Param("versionId") Long versionId);

    List<BentelerIniVersionItem> getWork_VersionItem(@Param("workId") Long workId,
                                                     @Param("checkType") Integer checkType,
                                                     @Param("localDate") LocalDate localDate);

    List<getNowCheckStatusRes> getVersion_DateCheckStatus(@Param("checkStatus") Integer checkStatus, @Param("localDate") LocalDate localDate);

    //点检日期 点检类型 版本Id 工作站Id  ->点检项
    List<BentelerIniCheckItem> getVersion_CheckItem(@Param("req") GetVersionCheckItemReq req);

    List<getCheckResutGreadRes> getVersion_CheckResutGread(@Param("versionId") Long versionId, @Param("localDate") LocalDate localDate);


    //BentelerIniVersionItem getPlanCurrentVersionId(@Param("planId") Long planId);
}
