package com.factory.web.service.impl.fa;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicReference;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

import com.alibaba.excel.metadata.Head;
import com.alibaba.excel.write.merge.AbstractMergeStrategy;
import com.factory.base.entity.po.remote.Dept;
import com.factory.base.entity.po.remote.UserInfo;
import com.factory.user.config.handler.LoginContext;
import com.factory.user.service.UsersService;
import com.factory.user.util.AuthUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Sheet;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.excel.write.metadata.fill.FillConfig;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.factory.base.config.excel.MyHandler;
import com.factory.base.entity.aggregates.PageBean;
import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.entity.enumPo.PlanStatus;
import com.factory.base.entity.enumPo.PlanType;
import com.factory.base.entity.po.benteler.BentelerPlan;
import com.factory.base.util.res.ResponseBeanBuilder;
import com.factory.base.util.time.TimeConvert;
import com.factory.user.entity.vo.res.FileRes;
import com.factory.user.service.CommonService;
import com.factory.web.entity.fa.FirstArticleApprovalTask;
import com.factory.web.entity.fa.FirstArticleCalendar;
import com.factory.web.entity.fa.FirstArticleItem;
import com.factory.web.entity.fa.FirstArticleItemResult;
import com.factory.web.entity.fa.FirstArticleTask;
import com.factory.web.entity.fa.FirstArticleTaskHisBlob;
import com.factory.web.entity.fa.FirstArticleTitle;
import com.factory.web.entity.fa.FirstArticleTitleBlob;
import com.factory.web.entity.fa.FirstArticleWorkshop;
import com.factory.web.entity.fa.req.AddFaItemResultListReq;
import com.factory.web.entity.fa.req.AddFaItemResultReq;
import com.factory.web.entity.fa.req.AddFaPlanReq;
import com.factory.web.entity.fa.req.EditFaItemResultListReq;
import com.factory.web.entity.fa.req.EditFaItemResultReq;
import com.factory.web.entity.fa.req.EditFaPlanReq;
import com.factory.web.entity.fa.req.FirstArticleItemReq;
import com.factory.web.entity.fa.req.FirstArticleWorkshopReq;
import com.factory.web.entity.fa.req.SearchALLPlanListReq;
import com.factory.web.entity.fa.req.SearchFaCalendarReq;
import com.factory.web.entity.fa.req.SearchFaCheckRecordListReq;
import com.factory.web.entity.fa.req.SearchFaItemListForPadReq;
import com.factory.web.entity.fa.req.SearchFaItemNoGoListReq;
import com.factory.web.entity.fa.req.SearchFaItemReleaseCountReq;
import com.factory.web.entity.fa.req.SearchFaItemResultListReq;
import com.factory.web.entity.fa.req.SearchFaPlanCheckListReq;
import com.factory.web.entity.fa.req.SearchFaPlanListForPadReq;
import com.factory.web.entity.fa.req.SearchFaPlanReq;
import com.factory.web.entity.fa.req.SearchFaTaskInfoReq;
import com.factory.web.entity.fa.req.SearchFaTaskReq;
import com.factory.web.entity.fa.req.SearchFaWorkshopListForPadReq;
import com.factory.web.entity.fa.req.SearchFaWorkshopNoGoListReq;
import com.factory.web.entity.fa.req.SearchFaWsItemResultCountReq;
import com.factory.web.entity.fa.req.SearchHisPlanListReq;
import com.factory.web.entity.fa.req.SearchUserListReq;
import com.factory.web.entity.fa.req.SubmitFaTaskReq;
import com.factory.web.entity.fa.res.FaCalendarRes;
import com.factory.web.entity.fa.res.FaCheckRecordListRes;
import com.factory.web.entity.fa.res.FaItemListForPadRes;
import com.factory.web.entity.fa.res.FaItemNoGoListRes;
import com.factory.web.entity.fa.res.FaNoGoTaskAapprovalRes;
import com.factory.web.entity.fa.res.FaPlanListForPadRes;
import com.factory.web.entity.fa.res.FaPlanListRes;
import com.factory.web.entity.fa.res.FaPlanRes;
import com.factory.web.entity.fa.res.FaTaskRes;
import com.factory.web.entity.fa.res.FaTaskResForPad;
import com.factory.web.entity.fa.res.FaWorkshopNoGoListRes;
import com.factory.web.entity.fa.res.UserListRes;
import com.factory.web.entity.pm.ApprovalRule;
import com.factory.web.entity.pm.OnsiteApprovalPlan;
import com.factory.web.entity.vo.req.ExportInitialPlanDetailsReq;
import com.factory.web.mapper.fa.FirstArticleMapper;
import com.factory.web.mapper.pm.ApprovalRuleMapper;
import com.factory.web.service.BentelerPlanService;
import com.factory.web.service.FileService;
import com.factory.web.service.fa.FirstArticleApprovalTaskService;
import com.factory.web.service.fa.FirstArticleCalendarService;
import com.factory.web.service.fa.FirstArticleItemResultService;
import com.factory.web.service.fa.FirstArticleItemService;
import com.factory.web.service.fa.FirstArticleService;
import com.factory.web.service.fa.FirstArticleTaskHisBlobService;
import com.factory.web.service.fa.FirstArticleTaskService;
import com.factory.web.service.fa.FirstArticleTitleBlobService;
import com.factory.web.service.fa.FirstArticleWorkshopService;
import com.factory.web.service.impl.FileEntry;
import com.factory.web.service.pm.OnsiteApprovalPlanService;
import com.factory.web.service.pm.PlanBindService;
import com.factory.web.service.pm.PreventMistakeService;
import com.factory.wx.entity.req.SendMsgReq;
import com.factory.wx.service.WxService;

import cn.hutool.core.convert.Convert;
import lombok.extern.slf4j.Slf4j;


/**
 * 首件计划
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Slf4j
@Service("firstArticleService")
@Transactional(rollbackFor = Exception.class)
public class FirstArticleServiceImpl extends ServiceImpl<FirstArticleMapper, BentelerPlan> implements FirstArticleService {

    private static long ROLE_ID = 6;

    @Autowired
    private FirstArticleMapper firstArticleMapper;

    @Autowired
    private PreventMistakeService preventMistakeService;

    @Autowired
    private OnsiteApprovalPlanService onsiteApprovalPlanService;

    @Autowired
    private BentelerPlanService planService;

    @Autowired
    private FirstArticleCalendarService firstArticleCalendarService;

    @Autowired
    private FirstArticleTitleBlobService firstArticleTitleBlobService;

    @Autowired
    private FirstArticleWorkshopService firstArticleWorkshopService;

    @Autowired
    private FirstArticleItemService firstArticleItemService;

    @Autowired
    private FirstArticleItemResultService firstArticleItemResultService;

    @Autowired
    private FirstArticleTaskService firstArticleTaskService;

    @Autowired
    private FirstArticleApprovalTaskService firstArticleApprovalTaskService;

    @Autowired
    private FirstArticleTaskHisBlobService firstArticleTaskHisBlobService;

    @Autowired
    private CommonService commonService;
    @Autowired
    private UsersService usersService;

    @Autowired
    private PlanBindService planBindService;

    @Autowired
    private FileService fileService;

    @Autowired
    private WxService wxService;
    
    @Autowired
    private ApprovalRuleMapper approvalRuleMapper;

    /**
     * 新建首件计划
     *
     * @param req
     * @return
     */
    @Override
    public ResponseBean<Void> addFaPlan(AddFaPlanReq req){
        // 校验计划名称是否存在
        if (this.checkPlanNameExist(req.getBentelerPlanName(), null)) {
            return ResponseBeanBuilder.fail("计划名称已存在");
        }
        
            // 添加首件计划
            BentelerPlan plan = BentelerPlan.builder()
                    .planType(PlanType.首件.value)
                    .name(req.getBentelerPlanName())
                    .pauseFlag(false)
                    .effectiveDate(req.getEffectiveDate())
                    .status(PlanStatus.WAIT_APPROVAL.value)
                    .fileId(req.getUrl() != null ? req.getUrl().intValue() : null)
                    .build();
            planService.save(plan);
            // 添加首件、200件点检规则
            FirstArticleCalendar firstArticleCalendar = FirstArticleCalendar.builder()
                    .bentelerPlanId(plan.getId())
                    .firstStart(req.getFirstStart())
                    .firstRemind(TimeConvert.timeString2String(req.getFirstStart(), req.getFirstCheck() * 60, "HH:mm"))
                    .firstEnd(req.getFirstEnd())
                    .twoRemind(req.getTwoHundredSubmitTime())
                    .upleverTimeNum(req.getFirstUpdate())
                    .typeFlag(req.getTypeFlag())
                    .principalOneShift(req.getPrincipalOneShift())
                    .principalTwoShift(req.getPrincipalTwoShift())
                    .principalOneId(req.getPrincipalOneId())
                    .principalTwoId(req.getPrincipalTwoId())
                    .build();
            firstArticleCalendarService.save(firstArticleCalendar);
            // 添加表头信息
            try {
            FirstArticleTitleBlob firstArticleTitleBlob = FirstArticleTitleBlob.builder()
                    .bentelerPlanId(plan.getId())
                    .titleContent(this.objectToByteArray(req.getFirstArticleTitle()))
                    .build();
            firstArticleTitleBlobService.save(firstArticleTitleBlob);
            }catch (Exception e) {
            	e.printStackTrace();
			}
            // 添加工作站信息
            List<FirstArticleWorkshopReq> firstArticleWorkshopList = req.getFirstArticleWorkshopList();
            for (FirstArticleWorkshopReq firstArticleWorkshopReq : firstArticleWorkshopList) {
                FirstArticleWorkshop firstArticleWorkshop = FirstArticleWorkshop.builder()
                        .bentelerPlanId(plan.getId())
                        .wsName(firstArticleWorkshopReq.getWsName())
                        .plName(firstArticleWorkshopReq.getPlName())
                        .build();
                firstArticleWorkshopService.save(firstArticleWorkshop);
                // 添加巡检项目信息
                List<FirstArticleItemReq> firstArticleItemList = firstArticleWorkshopReq.getFirstArticleItemList();
                for (FirstArticleItemReq firstArticleItemReq : firstArticleItemList) {
                    FirstArticleItem firstArticleItem = FirstArticleItem.builder()
                            .workshopId(firstArticleWorkshop.getId())
                            .itemContent(firstArticleItemReq.getItemContent())
                            .itemStandard(firstArticleItemReq.getItemStandard())
                            .prefix(firstArticleItemReq.getPrefix())
                            .snoStart(firstArticleItemReq.getSnoStart())
                            .snoEnd(firstArticleItemReq.getSnoEnd())
                            .valFlag(firstArticleItemReq.getValFlag())
                            .valUp(firstArticleItemReq.getValUp())
                            .valDown(firstArticleItemReq.getValDown())
                            .valUnit(firstArticleItemReq.getValUnit())
                            .valOk(firstArticleItemReq.getValOk())
                            .valDesc(firstArticleItemReq.getValDesc())
                            .levelInfo(firstArticleItemReq.getLevelInfo())
                            .productInfo(firstArticleItemReq.getProductInfo())
                            .toolId(firstArticleItemReq.getToolId())
                            .toolDesc(firstArticleItemReq.getToolDesc())
                            .firstFlag(firstArticleItemReq.getFirstFlag())
                            .twoHundredFlag(firstArticleItemReq.getTwoHundredFlag())
                            .catchFlag(firstArticleItemReq.getCatchFlag())
                            .build();
                    firstArticleItemService.save(firstArticleItem);
                }
            }
            planService.updateById(BentelerPlan.builder()
                    .id(plan.getId())
                    .originalId(plan.getId())
                    .build());
            onsiteApprovalPlanService.setApprovalFirst(plan.getId(), false);
      
        return ResponseBeanBuilder.ok();
    }


    /**
     * 校验计划名是否存在
     *
     * @param name
     * @return true存在，false不存在
     */
    @Override
    public boolean checkPlanNameExist(String name, Long originalId) {
        int count = planService.count(
                Wrappers.<BentelerPlan>lambdaQuery()
                        .eq(BentelerPlan::getName, name)
                        .ne(originalId != null, BentelerPlan::getOriginalId, originalId)
        );
        if (count > 0) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 校验工作站名是否存在
     *
     * @param wsName
     * @return true存在，false不存在
     */
    @Override
    public boolean checkWsNameExist(String wsName) {
        int count = firstArticleWorkshopService.count(
                Wrappers.<FirstArticleWorkshop>lambdaQuery().eq(FirstArticleWorkshop::getWsName, wsName));
        if (count > 0) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 取得防错计划信息
     *
     * @param req
     * @return 防错计划信息
     */
    @Override
    public FaPlanRes getFaPlan(SearchFaPlanReq req) {
        BentelerPlan plan = planService.getById(req.getBentelerPlanId());
        FaPlanRes faPlanRes = new FaPlanRes();
        faPlanRes.setBentelerPlanId(plan.getId());
        faPlanRes.setBentelerPlanName(plan.getName());
        faPlanRes.setPlanType(plan.getPlanType());
        faPlanRes.setEffectiveDate(plan.getEffectiveDate());
        Integer fileId = plan.getFileId();
        if (fileId != null) {
            FileEntry file = fileService.getById(fileId);
            faPlanRes.setUrl(fileId);
            faPlanRes.setFileNm(Optional.ofNullable(file.getFileNm()).orElse(""));
        }

        List<FirstArticleCalendar> firstArticleCalendarList = firstArticleCalendarService.list(Wrappers.<FirstArticleCalendar>lambdaQuery()
                .eq(FirstArticleCalendar::getBentelerPlanId, plan.getId()));

        faPlanRes.setFirstArticleCalendarList(firstArticleCalendarList);

        try {
            FirstArticleTitleBlob firstArticleTitleBlob = firstArticleTitleBlobService.getOne(new LambdaQueryWrapper<FirstArticleTitleBlob>()
                    .eq(FirstArticleTitleBlob::getBentelerPlanId, req.getBentelerPlanId()));
            faPlanRes.setFirstArticleTitle((FirstArticleTitle) this.byteArrayToObject(firstArticleTitleBlob.getTitleContent()));

            /* 取得文件信息 */
            FileEntry fileEntry = fileService.getById(faPlanRes.getFirstArticleTitle().getUploadAttachmentId());
            if (fileEntry != null) {
                faPlanRes.setFileNm(fileEntry.getFileNm());
            }

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        List<FirstArticleWorkshop> firstArticleWorkshopList = firstArticleWorkshopService.list(Wrappers.<FirstArticleWorkshop>lambdaQuery()
                .eq(FirstArticleWorkshop::getBentelerPlanId, plan.getId()));
        for (FirstArticleWorkshop firstArticleWorkshop : firstArticleWorkshopList) {
            List<FirstArticleItem> firstArticleItemList = firstArticleItemService.list(Wrappers.<FirstArticleItem>lambdaQuery()
                    .eq(FirstArticleItem::getWorkshopId, firstArticleWorkshop.getId()));
            firstArticleWorkshop.setFirstArticleItemList(firstArticleItemList);
        }
        faPlanRes.setFirstArticleWorkshopList(firstArticleWorkshopList);

        return faPlanRes;
    }

    /**
     * 校验当前计划是否审批通过
     *
     * @param bentelerPlanId
     * @return true通过，false不通过
     */
    @Override
    public boolean checkApprovalPlan(long bentelerPlanId) {
        int count = onsiteApprovalPlanService.count(
                Wrappers.<OnsiteApprovalPlan>lambdaQuery()
                        .eq(OnsiteApprovalPlan::getBentelerPlanId, bentelerPlanId)
                        .eq(OnsiteApprovalPlan::getApprovalLevel, 2)
                        .eq(OnsiteApprovalPlan::getStatus, 1));
        if (count > 0) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 修改首件计划
     *
     * @param req
     * @return
     */
    @Override
    public ResponseBean<Void> editFaPlan(EditFaPlanReq req) {
        try {
            BentelerPlan plan = null;
            BentelerPlan oldPlan = planService.getById(req.getBentelerPlanId());
            BentelerPlan oldEdit = null;
            if (oldPlan.getStatus() >= PlanStatus.APPROVAL_PASS.value) {
                // 保证未审核通过的版本只有一个
                oldEdit = planService.lambdaQuery()
                        .eq(BentelerPlan::getOriginalId, oldPlan.getOriginalId())
                        .in(BentelerPlan::getStatus, PlanStatus.WAIT_APPROVAL.value, PlanStatus.APPROVAL_REFUSE.value)
                        .one();
            }
            if (oldEdit != null) {
                oldPlan = oldEdit;
            }
            if (!req.getBentelerPlanName().equals(oldPlan.getName())) {
                // 校验计划名称是否存在
                if (this.checkPlanNameExist(req.getBentelerPlanName(), oldPlan.getId())) {
                    return ResponseBeanBuilder.fail("计划名称已存在");
                }
            }
            boolean clearApproval = false;
            if (oldPlan.getStatus() >= PlanStatus.APPROVAL_PASS.value) { // 审批通过
                // 添加首件计划
                plan = BentelerPlan.builder()
                        .planType(PlanType.首件.value)
                        .name(req.getBentelerPlanName())
                        .pauseFlag(false)
                        .effectiveDate(req.getEffectiveDate())
                        .prevId(oldPlan.getId())
                        .originalId(oldPlan.getOriginalId())
                        .status(PlanStatus.WAIT_APPROVAL.value)
                        .fileId(req.getUrl())
                        .build();
                planService.save(plan);
                // 添加首件、200件点检规则
                FirstArticleCalendar firstArticleCalendar = FirstArticleCalendar.builder()
                        .bentelerPlanId(plan.getId())
                        .firstStart(req.getFirstStart())
                        .firstRemind(TimeConvert.timeString2String(req.getFirstStart(), req.getFirstCheck() * 60, "HH:mm"))
                        .firstEnd(req.getFirstEnd())
                        .twoRemind(req.getTwoHundredSubmitTime())
                        .upleverTimeNum(req.getFirstUpdate())
                        .typeFlag(req.getTypeFlag())
                        .principalOneShift(req.getPrincipalOneShift())
                        .principalTwoShift(req.getPrincipalTwoShift())
                        .principalOneId(req.getPrincipalOneId())
                        .principalTwoId(req.getPrincipalTwoId())
                        .build();
                firstArticleCalendarService.save(firstArticleCalendar);
                // 添加表头信息
                FirstArticleTitleBlob firstArticleTitleBlob = FirstArticleTitleBlob.builder()
                        .bentelerPlanId(plan.getId())
                        .titleContent(this.objectToByteArray(req.getFirstArticleTitle()))
                        .build();
                firstArticleTitleBlobService.save(firstArticleTitleBlob);
                // 添加工作站信息
                List<FirstArticleWorkshopReq> firstArticleWorkshopList = req.getFirstArticleWorkshopList();
                for (FirstArticleWorkshopReq firstArticleWorkshopReq : firstArticleWorkshopList) {
                    FirstArticleWorkshop firstArticleWorkshop = FirstArticleWorkshop.builder()
                            .bentelerPlanId(plan.getId())
                            .wsName(firstArticleWorkshopReq.getWsName())
                            .plName(firstArticleWorkshopReq.getPlName())
                            .build();
                    firstArticleWorkshopService.save(firstArticleWorkshop);
                    // 添加巡检项目信息
                    List<FirstArticleItemReq> firstArticleItemList = firstArticleWorkshopReq.getFirstArticleItemList();
                    for (FirstArticleItemReq firstArticleItemReq : firstArticleItemList) {
                        FirstArticleItem firstArticleItem = FirstArticleItem.builder()
                                .workshopId(firstArticleWorkshop.getId())
                                .itemContent(firstArticleItemReq.getItemContent())
                                .itemStandard(firstArticleItemReq.getItemStandard())
                                .prefix(firstArticleItemReq.getPrefix())
                                .snoStart(firstArticleItemReq.getSnoStart())
                                .snoEnd(firstArticleItemReq.getSnoEnd())
                                .valFlag(firstArticleItemReq.getValFlag())
                                .valUp(firstArticleItemReq.getValUp())
                                .valDown(firstArticleItemReq.getValDown())
                                .valUnit(firstArticleItemReq.getValUnit())
                                .valOk(firstArticleItemReq.getValOk())
                                .valDesc(firstArticleItemReq.getValDesc())
                                .levelInfo(firstArticleItemReq.getLevelInfo())
                                .productInfo(firstArticleItemReq.getProductInfo())
                                .toolId(firstArticleItemReq.getToolId())
                                .toolDesc(firstArticleItemReq.getToolDesc())
                                .firstFlag(firstArticleItemReq.getFirstFlag())
                                .twoHundredFlag(firstArticleItemReq.getTwoHundredFlag())
                                .catchFlag(firstArticleItemReq.getCatchFlag())
                                .build();
                        firstArticleItemService.save(firstArticleItem);
                    }
                }
            } else {
                // 没审批通过 修改计划
                plan = BentelerPlan.builder()
                        .id(oldPlan.getId())
                        .name(req.getBentelerPlanName())
                        .effectiveDate(req.getEffectiveDate())
                        .status(PlanStatus.WAIT_APPROVAL.value)
                        .fileId(req.getUrl())
                        .build();
                planService.updateById(plan);
                // 删除首件、200件点检规则
                firstArticleCalendarService.remove(Wrappers.<FirstArticleCalendar>lambdaQuery()
                        .eq(FirstArticleCalendar::getBentelerPlanId, plan.getId()));
                // 重新添加首件、200件点检规则
                FirstArticleCalendar firstArticleCalendar = FirstArticleCalendar.builder()
                        .bentelerPlanId(plan.getId())
                        .firstStart(req.getFirstStart())
                        .firstRemind(TimeConvert.timeString2String(req.getFirstStart(), req.getFirstCheck() * 60, "HH:mm"))
                        .firstEnd(req.getFirstEnd())
                        .twoRemind(req.getTwoHundredSubmitTime())
                        .upleverTimeNum(req.getFirstUpdate())
                        .typeFlag(req.getTypeFlag())
                        .principalOneShift(req.getPrincipalOneShift())
                        .principalTwoShift(req.getPrincipalTwoShift())
                        .principalOneId(req.getPrincipalOneId())
                        .principalTwoId(req.getPrincipalTwoId())
                        .build();
                firstArticleCalendarService.save(firstArticleCalendar);
                // 修改表头信息
                LambdaUpdateWrapper<FirstArticleTitleBlob> lambdaUpdateWrapper = new LambdaUpdateWrapper<>();
                lambdaUpdateWrapper.eq(FirstArticleTitleBlob::getBentelerPlanId, plan.getId())
                        .set(FirstArticleTitleBlob::getTitleContent, this.objectToByteArray(req.getFirstArticleTitle()));
                firstArticleTitleBlobService.update(lambdaUpdateWrapper);
                // 删除巡检项目
                List<FirstArticleWorkshop> firstArticleWorkshopListTemp = firstArticleWorkshopService.list(Wrappers.<FirstArticleWorkshop>lambdaQuery()
                        .eq(FirstArticleWorkshop::getBentelerPlanId, plan.getId()));
                List<Long> workshopIdList = new ArrayList<Long>();
                for (FirstArticleWorkshop firstArticleWorkshop : firstArticleWorkshopListTemp) {
                    workshopIdList.add(firstArticleWorkshop.getId());
                }
                firstArticleItemService.remove(Wrappers.<FirstArticleItem>lambdaQuery()
                        .in(FirstArticleItem::getWorkshopId, workshopIdList));
                // 删除工作站
                firstArticleWorkshopService.remove(Wrappers.<FirstArticleWorkshop>lambdaQuery()
                        .eq(FirstArticleWorkshop::getBentelerPlanId, plan.getId()));
                // 添加工作站信息
                List<FirstArticleWorkshopReq> firstArticleWorkshopList = req.getFirstArticleWorkshopList();
                for (FirstArticleWorkshopReq firstArticleWorkshopReq : firstArticleWorkshopList) {
                    FirstArticleWorkshop firstArticleWorkshop = FirstArticleWorkshop.builder()
                            .bentelerPlanId(plan.getId())
                            .wsName(firstArticleWorkshopReq.getWsName())
                            .plName(firstArticleWorkshopReq.getPlName())
                            .build();
                    firstArticleWorkshopService.save(firstArticleWorkshop);
                    // 添加巡检项目信息
                    List<FirstArticleItemReq> firstArticleItemList = firstArticleWorkshopReq.getFirstArticleItemList();
                    for (FirstArticleItemReq firstArticleItemReq : firstArticleItemList) {
                        FirstArticleItem firstArticleItem = FirstArticleItem.builder()
                                .workshopId(firstArticleWorkshop.getId())
                                .itemContent(firstArticleItemReq.getItemContent())
                                .itemStandard(firstArticleItemReq.getItemStandard())
                                .prefix(firstArticleItemReq.getPrefix())
                                .snoStart(firstArticleItemReq.getSnoStart())
                                .snoEnd(firstArticleItemReq.getSnoEnd())
                                .valFlag(firstArticleItemReq.getValFlag())
                                .valUp(firstArticleItemReq.getValUp())
                                .valDown(firstArticleItemReq.getValDown())
                                .valUnit(firstArticleItemReq.getValUnit())
                                .valOk(firstArticleItemReq.getValOk())
                                .valDesc(firstArticleItemReq.getValDesc())
                                .levelInfo(firstArticleItemReq.getLevelInfo())
                                .productInfo(firstArticleItemReq.getProductInfo())
                                .toolId(firstArticleItemReq.getToolId())
                                .toolDesc(firstArticleItemReq.getToolDesc())
                                .firstFlag(firstArticleItemReq.getFirstFlag())
                                .twoHundredFlag(firstArticleItemReq.getTwoHundredFlag())
                                .catchFlag(firstArticleItemReq.getCatchFlag())
                                .build();
                        firstArticleItemService.save(firstArticleItem);
                    }
                }
                clearApproval = true;
            }
            onsiteApprovalPlanService.setApprovalFirst(plan.getId(), clearApproval);
        } catch (Exception e) {
            log.info("修改计划出现异常:参数{},结果{}", req, e);
            // 手动回滚事务
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
        }
        return ResponseBeanBuilder.ok();
    }

    /**
     * 取得首件计划点检列表
     *
     * @param req
     * @return 首件计划点检列表
     */
    @Override
    public ResponseBean<PageBean<FaPlanListRes>> getFaPlanCheckList(SearchFaPlanCheckListReq req) {
        Page<FaPlanListRes> page = new Page<>(req.getPage(), req.getSize());
        Page<FaPlanListRes> listResPage = firstArticleMapper.getFaPlanCheckList(page, req);
        return ResponseBeanBuilder.ok(listResPage, Function.identity());
    }


    /**
     * 取得Pad端防错计划列表
     *
     * @param req
     * @return Pad端防错计划列表
     */
    @Override
    public ResponseBean<List<FaPlanListForPadRes>> getFaPlanListForPad(SearchFaPlanListForPadReq req) {
        List<FaPlanListForPadRes> listRes = firstArticleMapper.getFaPlanListForPad(req);
        return ResponseBeanBuilder.ok(listRes, Function.identity());
    }

    /**
     * 取得Pad端首件计划对应的工作站
     *
     * @param req
     * @return 工作站
     */
    @Override
    public ResponseBean<List<FirstArticleWorkshop>> getFaWorkshopListForPad(SearchFaWorkshopListForPadReq req)  throws Exception{
        /* 取得task信息 */
        SearchFaTaskInfoReq searchFaTaskInfoReq = new SearchFaTaskInfoReq();
        searchFaTaskInfoReq.setBentelerPlanId(req.getBentelerPlanId());
        searchFaTaskInfoReq.setTypeFlag(req.getTypeFlag());
        searchFaTaskInfoReq.setTaskId(req.getTaskId());
        //获取对应task信息
        FirstArticleTask faTaskInfo = null;
        if (req.getTypeFlag() == 0 || req.getTypeFlag() == 1) { // 0表示首件 1表示200件
            searchFaTaskInfoReq.setUserId(req.getUserId());
            faTaskInfo = this.getFaTaskInfo(searchFaTaskInfoReq);
        } else { // 2表示中断
            /* 取得中断最新的task */
            faTaskInfo = this.getFaTaskInfoCatchLatest(searchFaTaskInfoReq);
        }
        FirstArticleCalendar calendar = firstArticleCalendarService.getById(faTaskInfo.getFirstArticleCalendarId());
        
        long firstArticleTaskId = 0;
        if (faTaskInfo != null) {
            firstArticleTaskId = faTaskInfo.getId();
        }
        //工作站列表（包含此类别检查 W前缀的  只有周一才查出来）
        List<FirstArticleWorkshop> listRes = firstArticleMapper.getFaWorkshopListForPad(req);

        SearchFaItemListForPadReq searchFaItemListReq = null;
        SearchFaWsItemResultCountReq searchFaWsItemResultCountReq = null;
        for (FirstArticleWorkshop firstArticleWorkshop : listRes) {
        	firstArticleWorkshop.setTaskId(firstArticleTaskId);
            /* 取得点检项目 */
            searchFaItemListReq = new SearchFaItemListForPadReq();
            searchFaItemListReq.setWorkshopId(firstArticleWorkshop.getId());
            searchFaItemListReq.setTypeFlag(req.getTypeFlag());
            List<FaItemListForPadRes> listResTemp = firstArticleMapper.getFaItemListForPad(searchFaItemListReq);
            /* 计算点检项目数 */
            int itemCount = 0;
            for (FaItemListForPadRes faItem : listResTemp) {
                int start = faItem.getSnoStart();
                int end = faItem.getSnoEnd();

                itemCount += (end - start + 1);
            }

            searchFaWsItemResultCountReq = new SearchFaWsItemResultCountReq();
            searchFaWsItemResultCountReq.setFirstArticleTaskId(firstArticleTaskId);
            searchFaWsItemResultCountReq.setWorkshopId(firstArticleWorkshop.getId());
//    		int itemCount = firstArticleMapper.getFaWsItemCount(searchFaWsItemResultCountReq);
            int itemResultCount = firstArticleMapper.getFaWsItemResultCount(searchFaWsItemResultCountReq);
            if (itemCount == itemResultCount) {
                firstArticleWorkshop.setAllCheckFlag(1);
            } else {
                firstArticleWorkshop.setAllCheckFlag(0);
            }
        }
        ResponseBean<List<FirstArticleWorkshop>> r = ResponseBeanBuilder.ok(listRes, Function.identity());
        if(calendar!=null) {
        	r.setMessage(calendar.getTypeFlag());
        }
        return r;
    }

    /**
     * 取得Pad端巡检项目
     *
     * @param req
     * @return 巡检项目
     */
    @Override
    public ResponseBean<List<FaItemListForPadRes>> getFaItemListForPad(SearchFaItemListForPadReq req)  throws Exception{
        /* 取得task信息 */
        SearchFaTaskInfoReq searchFaTaskInfoReq = new SearchFaTaskInfoReq();
        searchFaTaskInfoReq.setBentelerPlanId(req.getBentelerPlanId());
        searchFaTaskInfoReq.setTypeFlag(req.getTypeFlag());
        searchFaTaskInfoReq.setTaskId(req.getTaskId());
        FirstArticleTask faTaskInfo = null;
        if (req.getTypeFlag() == 0 || req.getTypeFlag() == 1) { // 0表示首件 1表示200件
            searchFaTaskInfoReq.setUserId(req.getUserId());
            faTaskInfo = this.getFaTaskInfo(searchFaTaskInfoReq);
        } else { // 2表示中断
            /* 取得中断最新的task */
            faTaskInfo = this.getFaTaskInfoCatchLatest(searchFaTaskInfoReq);
        }

        long firstArticleTaskId = 0;
        if (faTaskInfo != null) {
            firstArticleTaskId = faTaskInfo.getId();
        }

        /* 取得点检项目 */
        List<FaItemListForPadRes> listResTemp = firstArticleMapper.getFaItemListForPad(req);

        List<FaItemListForPadRes> listRes = new ArrayList<FaItemListForPadRes>();
        for (FaItemListForPadRes faItemListForPadRes : listResTemp) {
            /* 序号拆分（从1到10，就拆分成10条） */
            int snoStart = faItemListForPadRes.getSnoStart();
            int snoEnd = faItemListForPadRes.getSnoEnd();

            FaItemListForPadRes itemInfo = null;
            for (int i = snoStart; i <= snoEnd; i++) {
                itemInfo = new FaItemListForPadRes();

                itemInfo.setSno(i);
                itemInfo.setId(faItemListForPadRes.getId());
                itemInfo.setWorkshopId(faItemListForPadRes.getWorkshopId());
                itemInfo.setItemContent(faItemListForPadRes.getItemContent());
                itemInfo.setItemStandard(faItemListForPadRes.getItemStandard());
                itemInfo.setPrefix(faItemListForPadRes.getPrefix());
                itemInfo.setSnoStart(faItemListForPadRes.getSnoStart());
                itemInfo.setSnoEnd(faItemListForPadRes.getSnoEnd());
                itemInfo.setValFlag(faItemListForPadRes.getValFlag());
                itemInfo.setValUp(faItemListForPadRes.getValUp());
                itemInfo.setValDown(faItemListForPadRes.getValDown());
                itemInfo.setValOk(faItemListForPadRes.getValOk());
                itemInfo.setValDesc(faItemListForPadRes.getValDesc());
                itemInfo.setLevelInfo(faItemListForPadRes.getLevelInfo());
                itemInfo.setProductInfo(faItemListForPadRes.getProductInfo());
                itemInfo.setToolId(faItemListForPadRes.getToolId());
                itemInfo.setToolDesc(faItemListForPadRes.getToolDesc());
                itemInfo.setFirstFlag(faItemListForPadRes.getFirstFlag());
                itemInfo.setTwoHundredFlag(faItemListForPadRes.getTwoHundredFlag());
                itemInfo.setCatchFlag(faItemListForPadRes.getCatchFlag());
                itemInfo.setValUnit(faItemListForPadRes.getValUnit());

                /* 取得检查结果 */
                FirstArticleItemResult firstArticleItemResult = firstArticleItemResultService.getOne(Wrappers.<FirstArticleItemResult>lambdaQuery()
                        .eq(FirstArticleItemResult::getFirstArticleTaskId, firstArticleTaskId)
                        .eq(FirstArticleItemResult::getFirstArticleItemId, itemInfo.getId())
                        .eq(FirstArticleItemResult::getSno, itemInfo.getSno()));
                if (firstArticleItemResult != null) {
                    itemInfo.setResult(firstArticleItemResult.getResult());
                    itemInfo.setValCheck(firstArticleItemResult.getVal());
                    itemInfo.setValDescCheck(firstArticleItemResult.getValDesc());
                    itemInfo.setToolDescCheck(firstArticleItemResult.getToolDesc());
                    itemInfo.setAbnormal(firstArticleItemResult.getAbnormal());
                    itemInfo.setOrderNumber(firstArticleItemResult.getOrderNumber());
                }

                listRes.add(itemInfo);
            }
        }

        return ResponseBeanBuilder.ok(listRes, Function.identity());
    }

    /**
     * 添加巡检项目检查结果
     *
     * @param req
     * @return
     */
    @Override
    public ResponseBean<Void> addFaItemResult(AddFaItemResultListReq req) {
        /* 取得task信息 */
        SearchFaTaskInfoReq searchFaTaskInfoReq = new SearchFaTaskInfoReq();
        searchFaTaskInfoReq.setBentelerPlanId(req.getBentelerPlanId());
        searchFaTaskInfoReq.setTypeFlag(req.getTypeFlag());
        if (req.getTypeFlag() == 0 || req.getTypeFlag() == 1) { // 0表示首件 1表示200件
            searchFaTaskInfoReq.setUserId(req.getUserId());
        } else { // 2表示中断
//            searchFaTaskInfoReq.setStatus(0); // task状态为0初始化
        }
        searchFaTaskInfoReq.setTaskId(req.getTaskId());
        FirstArticleTask faTaskInfo = this.getFaTaskInfo(searchFaTaskInfoReq);

        long firstArticleTaskId = 0;
        if (req.getTypeFlag() == 0 || req.getTypeFlag() == 1) { // 0表示首件 1表示200件
            if (faTaskInfo == null) {
                return ResponseBeanBuilder.fail("计划任务不存在！");
            } else {
                if (faTaskInfo.getStatus() == 0) {
                    firstArticleTaskId = faTaskInfo.getId();
                } else {
                    return ResponseBeanBuilder.fail("该计划任务已处理！无需重复提交！");
                }
            }
        } else { // 2表示中断
            if (faTaskInfo == null) { // 没有初始化状态的task，新建一个
                // 根据planId和type类型 获取中断对应的规则
                FirstArticleCalendar firstArticleCalendar = firstArticleCalendarService.getOne(new LambdaQueryWrapper<FirstArticleCalendar>()
                        .eq(FirstArticleCalendar::getBentelerPlanId, req.getBentelerPlanId())
                        .like(FirstArticleCalendar::getTypeFlag, "2"));
                // 创建一个新的中断task
                FirstArticleTask firstArticleTask = FirstArticleTask.builder()
                        .firstArticleCalendarId(firstArticleCalendar.getId())
                        .status(0)
                        .taskTime(LocalDate.now())
                        .remindTaskFlag(0)
                        .remindNoworkFlag(0)
                        .typeFlag(2)
                        .build();
                firstArticleTaskService.save(firstArticleTask);
                firstArticleTaskId = firstArticleTask.getId();
            } else { // 存在一个初始化状态的task，就用这个
                firstArticleTaskId = faTaskInfo.getId();
            }
        }
        List<AddFaItemResultReq> addFaItemResultList = req.getAddFaItemResultList();
        /* 删除上一次保存结果 */
        List<Long> firstArticleItemIdList = new ArrayList<>();
        for (AddFaItemResultReq itemResult : addFaItemResultList) {
            firstArticleItemIdList.add(itemResult.getFirstArticleItemId());
        }

        firstArticleItemResultService.remove(Wrappers.<FirstArticleItemResult>lambdaQuery()
                .eq(FirstArticleItemResult::getFirstArticleTaskId, firstArticleTaskId)
                .in(FirstArticleItemResult::getFirstArticleItemId, firstArticleItemIdList));

        /* 添加新的检查结果 */
//    	List<AddFaItemResultReq> addFaItemResultList = req.getAddFaItemResultList();
        for (AddFaItemResultReq addFaItemResult : addFaItemResultList) {
            FirstArticleItemResult firstArticleItemResult = FirstArticleItemResult.builder()
                    .firstArticleTaskId(firstArticleTaskId)
                    .firstArticleItemId(addFaItemResult.getFirstArticleItemId())
                    .val(addFaItemResult.getVal())
                    .valDesc(addFaItemResult.getValDesc())
                    .result(addFaItemResult.getResult())
                    .prefix(addFaItemResult.getPrefix())
                    .sno(addFaItemResult.getSno())
                    .toolDesc(addFaItemResult.getToolDesc())
                    .abnormal(addFaItemResult.getAbnormal())
                    .orderNumber(addFaItemResult.getOrderNumber())
                    .build();
            firstArticleItemResultService.save(firstArticleItemResult);
        }

        return ResponseBeanBuilder.ok();
    }

    /**
     * 任务提交
     *
     * @param req
     * @return
     */
    @Override
    public ResponseBean<Void> submitFaTask(SubmitFaTaskReq req) {
        /* 取得task信息 */
        SearchFaTaskInfoReq searchFaTaskInfoReq = new SearchFaTaskInfoReq();
        searchFaTaskInfoReq.setBentelerPlanId(req.getBentelerPlanId());
        searchFaTaskInfoReq.setTypeFlag(req.getTypeFlag());
        if (req.getTypeFlag() == 0 || req.getTypeFlag() == 1) { // 0表示首件 1表示200件
            searchFaTaskInfoReq.setUserId(req.getUserId());
        } else { // 2表示中断
//            searchFaTaskInfoReq.setStatus(0); // task状态为0初始化 多个taskId的时候不行
        }
        searchFaTaskInfoReq.setTaskId(req.getTaskId());
        
        FirstArticleTask faTaskInfo = this.getFaTaskInfo(searchFaTaskInfoReq);
       
        long firstArticleTaskId = 0;
        if (req.getTypeFlag() == 0 || req.getTypeFlag() == 1) { // 0表示首件 1表示200件
            if (faTaskInfo == null) {
                return ResponseBeanBuilder.fail("计划任务不存在！");
            } else {
                if (faTaskInfo.getStatus() == 0 || faTaskInfo.getStatus() == 3) { // 首次提交和重检提交

                    firstArticleTaskId = faTaskInfo.getId();
                } else {
                    return ResponseBeanBuilder.fail("该计划任务已处理！无需重复提交！");
                }
            }
        } else { // 2表示中断
            if (faTaskInfo == null) { // 没有初始化状态的task，新建一个
                return ResponseBeanBuilder.fail("请先完成点检！");
            } else { // 存在一个初始化状态的task，就用这个
                firstArticleTaskId = faTaskInfo.getId();
            }
        }
        if(faTaskInfo.getStatus()==3&&!req.getRecheckFlag()) {
        	return ResponseBeanBuilder.fail("请在重检列表中操作重检任务");
        }
        /* 取得task下的所有条目检查结果 */
        List<FirstArticleItemResult> firstArticleItemResultList = firstArticleItemResultService.list(Wrappers.<FirstArticleItemResult>lambdaQuery()
                .eq(FirstArticleItemResult::getFirstArticleTaskId, firstArticleTaskId));

        /* task提交时，备份result到resultBak */
        for (FirstArticleItemResult firstArticleItemResult : firstArticleItemResultList) {
            FirstArticleItemResult fair = FirstArticleItemResult.builder()
                    .id(firstArticleItemResult.getId())
                    .resultBak(firstArticleItemResult.getResult())
                    .build();
            firstArticleItemResultService.updateById(fair);
        }

        boolean flag = true; // true表示巡检项目都通过，false表示巡检项目有不通过的
        for (FirstArticleItemResult firstArticleItemResult : firstArticleItemResultList) {
            if (firstArticleItemResult.getResult() == 1) {
                flag = false;
                break;
            }
        }
        FirstArticleTask firstArticleTask = FirstArticleTask.builder()
                .id(firstArticleTaskId)
                .status(4)
                .build();
        //首次提交记录点检人点检时间
        if (faTaskInfo.getStatus() == 0) {
            firstArticleTask.setSubmitTime(LocalDateTime.now());
            firstArticleTask.setSubmitUserId(req.getUserId());
        }
        if (flag) { // 巡检项目都通过
            firstArticleTask.setStatus(4);
            firstArticleTaskService.updateById(firstArticleTask);
        } else { // 巡检项目有不通过的
            /* 更新任务为1待审核状态。等待后续审核 */
            firstArticleTask.setStatus(1);
            firstArticleTaskService.updateById(firstArticleTask);

            /* 删除之前的审批记录 */
            firstArticleApprovalTaskService.remove(Wrappers.<FirstArticleApprovalTask>lambdaQuery()
                    .eq(FirstArticleApprovalTask::getFirstArticleTaskId, firstArticleTask.getId()));
            this.setApproval(firstArticleTask.getId(),null);

        }

        /* 更新中断的操作人 */
        if (req.getTypeFlag() == 2) {
            // TODO 更新task表
        }

        return ResponseBeanBuilder.ok();
    }
    /* 取得审批人 approvalLevel=1级审批 type=2首件任务审批 */
    private void setApproval(Long taskId,Long userId) {
		ApprovalRule approvalRuleNextLevel = approvalRuleMapper.selectOne(Wrappers.<ApprovalRule>lambdaQuery()
                .eq(ApprovalRule::getType, ApprovalRule.APPROVAL_TYPE_FA)
                .orderByAsc(ApprovalRule::getApprovalLevel)
                .last("limit 1"));
		setApproval(approvalRuleNextLevel,taskId,userId);
	}
    @Override
    public void setApproval(ApprovalRule approvalRuleNextLevel,Long taskId,Long userId) {
	    if (approvalRuleNextLevel!=null) {
            int approvalLevel = approvalRuleNextLevel.getApprovalLevel();
            firstArticleApprovalTaskService.save(FirstArticleApprovalTask.builder()
                    .firstArticleTaskId(taskId)
                    .approvalLevel(String.valueOf(approvalLevel))
                    .approvalRole(approvalRuleNextLevel.getRoleId())
                    .status(0)
                    .build());
            FirstArticleTask firstArticleTask = firstArticleTaskService.getById(taskId);
            FirstArticleCalendar calendar = firstArticleCalendarService.getById(firstArticleTask.getFirstArticleCalendarId());
            BentelerPlan plan = this.getById(calendar.getBentelerPlanId());
            String type = firstArticleTask.getTypeFlag() == 0 ? "首件" : firstArticleTask.getTypeFlag() == 1 ? "200件" : "中断";
            String planName = plan.getName().length() > 15 ? (plan.getName().substring(0, 12) + "...") : plan.getName();
			//向下一级别发送提醒
			wxService.sendWechatMessageByRole(SendMsgReq.builder()
				.title("计划放行("+type+")")
		        .content(planName+"待审批")
		        .pageIndex("/pagesPlan/pass")
	            .fromUserId(userId)
	            .build(),approvalRuleNextLevel.getRoleId());
		}
    }
    /**
     * 取得不放行任务对应的工作站
     *
     * @param req
     * @return 不放行任务对应的工作站
     */
    @Override
    public ResponseBean<List<FaWorkshopNoGoListRes>> getFaWorkshopNoGoList(SearchFaWorkshopNoGoListReq req) {
        List<FaWorkshopNoGoListRes> faWorkshopNoGoList = firstArticleMapper.getFaWorkshopNoGoList(req);
        SearchFaWsItemResultCountReq searchFaWsItemResultCountReq = null;
        FirstArticleTask task = firstArticleTaskService.getById(req.getFirstArticleTaskId());
        FirstArticleCalendar calendar = firstArticleCalendarService.getById(task.getFirstArticleCalendarId());
        for (FaWorkshopNoGoListRes faWorkshop : faWorkshopNoGoList) {
        	faWorkshop.setTaskId(task.getId());
            searchFaWsItemResultCountReq = new SearchFaWsItemResultCountReq();
            searchFaWsItemResultCountReq.setFirstArticleTaskId(req.getFirstArticleTaskId());
            searchFaWsItemResultCountReq.setWorkshopId(faWorkshop.getWorkshopId());
            int itemResultCount = firstArticleMapper.getFaRepeatItemResultCount(searchFaWsItemResultCountReq);
            if (itemResultCount == 0) {
                faWorkshop.setAllCheckFlag(1);
            } else {
                faWorkshop.setAllCheckFlag(0);
            }
        }
        
        ResponseBean<List<FaWorkshopNoGoListRes>> r = ResponseBeanBuilder.ok(faWorkshopNoGoList, Function.identity());
        if(calendar!=null) {
        	r.setMessage(calendar.getTypeFlag());
        }
        return r;
    }

    /**
     * 取得不放行任务对应的点检项目
     *
     * @param req
     * @return 不放行任务对应的点检项目
     */
    @Override
    public ResponseBean<List<FaItemNoGoListRes>> getFaItemNoGoList(SearchFaItemNoGoListReq req) {
        List<FaItemNoGoListRes> faItemNoGoList = firstArticleMapper.getFaItemNoGoList(req);
        return ResponseBeanBuilder.ok(faItemNoGoList, Function.identity());
    }


    /**
     * 修改巡检项目检查结果(这里只有重检走这里)
     *
     * @param req
     * @return
     */
    @Override
    public ResponseBean<Void> editFaItemResult(EditFaItemResultListReq req) {
        /* 更新巡检项目检查结果 */
        List<EditFaItemResultReq> editFaItemResultList = req.getEditFaItemResultList();
        for (EditFaItemResultReq editFaItemResult : editFaItemResultList) {
            FirstArticleItemResult firstArticleItemResult = FirstArticleItemResult.builder()
                    .id(editFaItemResult.getId())
                    .val(editFaItemResult.getVal())
                    .valDesc(editFaItemResult.getValDesc())
                    .result(editFaItemResult.getResult())
                    .prefix(editFaItemResult.getPrefix())
                    .result(0)
                    .sno(editFaItemResult.getSno())
                    .toolDesc(editFaItemResult.getToolDesc())
                    .abnormal(editFaItemResult.getAbnormal())
                    .orderNumber(editFaItemResult.getOrderNumber())
                    .build();
            firstArticleItemResultService.updateById(firstArticleItemResult);
        }

        return ResponseBeanBuilder.ok();
    }


    /**
     * 任务和巡检结果记录历史
     *
     * @param @onsiteTaskId
     * @return
     */
    @Override
    public void setFirstArticleTaskHis(Long firstArticleTaskId) {
        /* 任务和巡检结果记录历史 */
        FaTaskRes faTaskRes = new FaTaskRes();
        FirstArticleTask firstArticleTask = firstArticleTaskService.getById(firstArticleTaskId);
        faTaskRes.setFirstArticleTaskId(firstArticleTask.getId());
        faTaskRes.setFirstArticleCalendarId(firstArticleTask.getFirstArticleCalendarId());
        faTaskRes.setStatus(firstArticleTask.getStatus());
        faTaskRes.setTaskTime(firstArticleTask.getTaskTime());
        faTaskRes.setRemindTaskFlag(firstArticleTask.getRemindTaskFlag());
        faTaskRes.setRemindNoworkFlag(firstArticleTask.getRemindNoworkFlag());

        List<FirstArticleItemResult> firstArticleItemResultList = firstArticleItemResultService.list(Wrappers.<FirstArticleItemResult>lambdaQuery()
                .eq(FirstArticleItemResult::getFirstArticleTaskId, firstArticleTaskId));
        faTaskRes.setFirstArticleItemResultList(firstArticleItemResultList);

        try {
            FirstArticleTaskHisBlob firstArticleTaskHisBlob = FirstArticleTaskHisBlob.builder()
                    .firstArticleTaskId(firstArticleTaskId)
                    .hisContent(this.objectToByteArray(faTaskRes))
                    .build();
            firstArticleTaskHisBlobService.save(firstArticleTaskHisBlob);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    /**
     * 取得表头信息
     *
     * @param bentelerPlanId
     * @return 表头信息
     */
    @Override
    public FirstArticleTitle getFaTitle(Long bentelerPlanId) {
        FirstArticleTitleBlob firstArticleTitleBlob = firstArticleTitleBlobService.getOne(new LambdaQueryWrapper<FirstArticleTitleBlob>()
                .eq(FirstArticleTitleBlob::getBentelerPlanId, bentelerPlanId));

        FirstArticleTitle firstArticleTitle = new FirstArticleTitle();
        try {
            firstArticleTitle = (FirstArticleTitle) this.byteArrayToObject(firstArticleTitleBlob.getTitleContent());
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return firstArticleTitle;
    }


    /**
     * 取得任务（首件、200件都是后台生成的任务，每个用户、计划、当天、类型（首件或200件））对应的应该是一个task。中断的task可以随便提交，所以要取状态是0初始化的，用户是-1这个userId不用传
     *
     * @param req
     * @return 任务
     */
    @Override
    public FirstArticleTask getFaTaskInfo(SearchFaTaskInfoReq req) {
        FirstArticleTask firstArticleTask = firstArticleMapper.getFaTaskInfo(req);
        return firstArticleTask;
    }

    /**
     * 查询中断最新的task
     * 如果没有未完成创建一个未完成的
     *
     * @param req
     * @return 任务
     */
    @Override
    public FirstArticleTask getFaTaskInfoCatchLatest(SearchFaTaskInfoReq req) throws Exception{
    	//最新未完成的
        FirstArticleTask firstArticleTask = firstArticleMapper.getFaTaskInfoCatchLatest(req);
        if(firstArticleTask==null) {
        	
			FirstArticleCalendar calendar = firstArticleCalendarService.lambdaQuery()
					.eq(FirstArticleCalendar::getBentelerPlanId, req.getBentelerPlanId()).last("limit 1").one();
        	if(calendar==null||!calendar.getTypeFlag().contains("2")) {
        		log.warn("当前计划不支持中断{}",req);
        		throw new Exception("当前计划不支持中断");
        	}
        	//TODO 新建一个任务
        	firstArticleTask = FirstArticleTask.builder()
        			.firstArticleCalendarId(calendar.getId())
        			.typeFlag(2)
        			.taskTime(LocalDate.now())
        			.status(0)
        			.remindNoworkFlag(0)
        			.remindTaskFlag(0)
        			.build();
        	
        	firstArticleTaskService.save(firstArticleTask);
        }else {
        	firstArticleTask = firstArticleTaskService.getById(firstArticleTask.getId());
        }
        return firstArticleTask;
    }

    /**
     * 取得不放行任务对应的质量经理审批信息
     *
     * @param req
     * @return 不放行任务对应的质量经理审批信息
     */
    @Override
    public ResponseBean<FaNoGoTaskAapprovalRes> getFaNoGoTaskAapproval(SearchFaTaskReq req) {
        FaNoGoTaskAapprovalRes faNoGoTaskAapprovalRes = firstArticleMapper.getFaNoGoTaskAapproval(req);
        return ResponseBeanBuilder.ok(faNoGoTaskAapprovalRes);
    }

    /**
     * 取得所有计划
     *
     * @param req
     * @return 所有计划
     */
    @Override
    public ResponseBean<List<BentelerPlan>> getALLPlanList(SearchALLPlanListReq req) {
        List<BentelerPlan> aLLPlanList = planService.list(Wrappers.<BentelerPlan>lambdaQuery()
                .eq(BentelerPlan::getPlanType, req.getPlanType())
                .eq(BentelerPlan::getPauseFlag, false)
                .eq(BentelerPlan::getStatus, PlanStatus.APPROVAL_FORMAL.value)
        );
        aLLPlanList.forEach(item -> {
            FirstArticleCalendar calendar = firstArticleCalendarService.getOne(Wrappers.<FirstArticleCalendar>lambdaQuery().eq(FirstArticleCalendar::getBentelerPlanId, item.getId()));
            Optional<FirstArticleCalendar> calendar1 = Optional.ofNullable(calendar);
            String userOneName = calendar1.map(calendaro -> calendaro.getPrincipalOneId()).map(principalOneId -> usersService.getById(principalOneId)).map(oneInfo -> oneInfo.getUsername()).orElse("");
            String userTwoName = calendar1.map(calendaro -> calendaro.getPrincipalTwoId()).map(principalOneId -> usersService.getById(principalOneId)).map(oneInfo -> oneInfo.getUsername()).orElse("");
            item.setCheckPerson(userOneName + "&" + userTwoName);
        });
        return ResponseBeanBuilder.ok(aLLPlanList, Function.identity());
    }

    @Override
    public ResponseBean<List<BentelerPlan>> getHisPlanList(SearchHisPlanListReq req) {
        BentelerPlan plan = planService.getById(req.getId());
        List<BentelerPlan> list = new ArrayList<>();
        if (plan != null) {

            if (plan.getOriginalId() == null) {
                list.add(plan);
            } else {
                list = planService.list(Wrappers.<BentelerPlan>lambdaQuery()
                        .eq(BentelerPlan::getPlanType, plan.getPlanType())
                        .eq(BentelerPlan::getOriginalId, plan.getOriginalId())
                        .in(BentelerPlan::getStatus, PlanStatus.APPROVAL_PASS.value, PlanStatus.APPROVAL_FORMAL.value, PlanStatus.HISTORY.value)
                );
            }

//            List<PlanBind> bindList = planBindService.list(Wrappers.<PlanBind>lambdaQuery().eq(PlanBind::getOldBentelerPlanId, req.getId())
//            		.select(PlanBind::getNewBentelerPlanId));
//            List<Long> psids = new ArrayList<>();
//            for (PlanBind b : bindList) {
//                psids.add(b.getNewBentelerPlanId());
//            }
//            psids.add(plan.getId());//把最初版本放入到信息里面
//            if(psids.size()>0){
//                List<OnsiteApprovalPlan> approvals=onsiteApprovalPlanService.list(Wrappers.<OnsiteApprovalPlan>lambdaQuery().eq(OnsiteApprovalPlan::getApprovalLevel,2)
//                       .eq(OnsiteApprovalPlan::getStatus,1)
//                       .in(OnsiteApprovalPlan::getBentelerPlanId,psids));
//                psids = new ArrayList<>();
//                for (OnsiteApprovalPlan b : approvals) {
//                    psids.add(b.getBentelerPlanId());
//                }
//                if(psids.size()>0){
//                	list = planService.list(Wrappers.<BentelerPlan>lambdaQuery() .eq(BentelerPlan::getPlanType, plan.getPlanType()).in(BentelerPlan::getId, psids));
//                    
//                }
//            }
        }

        return ResponseBeanBuilder.ok(list, Function.identity());
    }

    /**
     * 检查记录列表
     *
     * @param req
     * @return 检查记录列表
     */
    @Override
    public ResponseBean<FaCheckRecordListRes> getFaCheckRecordList(SearchFaCheckRecordListReq req) {
        FaCheckRecordListRes FaCheckRecordListRes = new FaCheckRecordListRes();
        List<FirstArticleWorkshop> firstArticleWorkshopList = firstArticleWorkshopService.list(Wrappers.<FirstArticleWorkshop>lambdaQuery()
                .eq(FirstArticleWorkshop::getBentelerPlanId, req.getBentelerPlanId()));
        for (FirstArticleWorkshop firstArticleWorkshop : firstArticleWorkshopList) {

            List<FirstArticleItem> firstArticleItemList = firstArticleItemService.list(Wrappers.<FirstArticleItem>lambdaQuery()
                    .eq(FirstArticleItem::getWorkshopId, firstArticleWorkshop.getId()));
            for (FirstArticleItem firstArticleItem : firstArticleItemList) {
                if (LocalDate.now().getDayOfWeek().getValue() != 1 && firstArticleItem.getPrefix().equals("W")) {
                    firstArticleItemList.remove(firstArticleItem);
                    continue;
                }
                FirstArticleWorkshop workshop = firstArticleWorkshopService.getById(firstArticleItem.getWorkshopId());
                firstArticleItem.setWorkshopName(workshop.getPlName() + "__" + workshop.getWsName());

                /* 首件检查结果 */
                List<FirstArticleItemResult> firstItemResultList = this.getItemResultList(firstArticleItem.getId(), req.getCheckDate(), 0);
                firstArticleItem.setFirstItemResultList(firstItemResultList);

                /* 200件检查结果 */
                List<FirstArticleItemResult> twoHundredItemResultList = this.getItemResultList(firstArticleItem.getId(), req.getCheckDate(), 1);
                firstArticleItem.setTwoHundredItemResultList(twoHundredItemResultList);

                /* 中断检查结果(一天提交多个中断task，暂时都取出来了) */
                List<FirstArticleItemResult> catchItemResultList = this.getItemResultList(firstArticleItem.getId(), req.getCheckDate(), 2);
                firstArticleItem.setCatchItemResultList(catchItemResultList);

                /* 判断当前检查项目是否是放行 */
                SearchFaItemReleaseCountReq searchFaItemReleaseCountReq = new SearchFaItemReleaseCountReq();
                searchFaItemReleaseCountReq.setCheckDate(req.getCheckDate());
                searchFaItemReleaseCountReq.setFirstArticleItemId(firstArticleItem.getId());
                int count = firstArticleMapper.getFaItemReleaseCount(searchFaItemReleaseCountReq);
                if (count > 0) {
                    firstArticleItem.setReleaseFlag(1); // 1有

                    firstArticleItem.setPermitDesc(firstArticleMapper.getFaItemRelease(searchFaItemReleaseCountReq)); // 备注
                } else {
                    firstArticleItem.setReleaseFlag(0); // 0没有
                }


            }

            firstArticleWorkshop.setFirstArticleItemList(firstArticleItemList);
        }
        FaCheckRecordListRes.setFirstArticleWorkshopList(firstArticleWorkshopList);

        return ResponseBeanBuilder.ok(FaCheckRecordListRes);
    }

    /**
     * 取得首件、200件、中断每天的点检记录
     *
     * @param req
     * @return 首件、200件、中断每天的点检记录
     */
    @Override
    public List<FirstArticleItemResult> getFaItemResultList(SearchFaItemResultListReq req) {
        List<FirstArticleItemResult> faItemResultList = firstArticleMapper.getFaItemResultList(req);
        return faItemResultList;
    }

    /**
     * 取得首件、200件、中断每天的点检记录
     *
     * @param firstArticleItemId
     * @param checkDate
     * @param typeFlag           0表示首件 1表示200件 2表示中断
     * @return 首件、200件、中断每天的点检记录
     */
    private List<FirstArticleItemResult> getItemResultList(long firstArticleItemId, String checkDate, int typeFlag) {
        SearchFaItemResultListReq searchFaItemResultListReq = new SearchFaItemResultListReq();
        searchFaItemResultListReq.setFirstArticleItemId(firstArticleItemId);
        searchFaItemResultListReq.setCheckDate(checkDate);
        searchFaItemResultListReq.setTypeFlag(typeFlag);

        List<FirstArticleItemResult> faItemResultList = this.getFaItemResultList(searchFaItemResultListReq);
        return faItemResultList;
    }

//    /**
//     * 判断检验结果是否填写完成
//     * @param req
//     * @return 检验结果是否填写完成
//     */
//	@Override
//	public FaAllCheckFlagRes getFaAllCheckFlag(SearchFaAllCheckFlagReq req) {
//		/* 取得task信息 */
//    	SearchFaTaskInfoReq searchFaTaskInfoReq = new SearchFaTaskInfoReq();
//    	searchFaTaskInfoReq.setBentelerPlanId(req.getBentelerPlanId());
//    	searchFaTaskInfoReq.setTypeFlag(req.getTypeFlag());
//
//    	FirstArticleTask faTaskInfo = null;
//    	if (req.getTypeFlag() == 0 || req.getTypeFlag() == 1) { // 0表示首件 1表示200件
//    		searchFaTaskInfoReq.setUserId(req.getUserId());
//    		faTaskInfo = this.getFaTaskInfo(searchFaTaskInfoReq);
//    	} else { // 2表示中断
//    		/* 取得中断最新的task */
//    		faTaskInfo = this.getFaTaskInfoCatchLatest(searchFaTaskInfoReq);
//    	}
//
//    	long firstArticleTaskId = 0;
//    	if (faTaskInfo != null) {
//    		firstArticleTaskId = faTaskInfo.getId();
//		}
//
//		SearchFaPlanReq searchFaPlanReq = new SearchFaPlanReq();
//		searchFaPlanReq.setBentelerPlanId(req.getBentelerPlanId());
//		int itemCount = firstArticleMapper.getFaItemCount(searchFaPlanReq);
//
//		SearchFaItemResultCountReq searchFaItemResultCountReq = new SearchFaItemResultCountReq();
//		searchFaItemResultCountReq.setBentelerPlanId(req.getBentelerPlanId());
//		searchFaItemResultCountReq.setFirstArticleTaskId(firstArticleTaskId);
//		int itemResultCount = firstArticleMapper.getFaItemResultCount(searchFaItemResultCountReq);
//
//		FaAllCheckFlagRes faAllCheckFlagRes = new FaAllCheckFlagRes();
//		if (itemCount == itemResultCount) {
//			faAllCheckFlagRes.setAllCheckFlag(1); // 全部完成
//		} else {
//			faAllCheckFlagRes.setAllCheckFlag(0); // 没完成
//		}
//
//		return faAllCheckFlagRes;
//	}


    /**
     * 取得用户列表
     *
     * @param @req
     * @return 取得用户列表
     */
    @Override
    public List<UserListRes> getUserList(List<Long> roleIds) {
        SearchUserListReq searchUserListReq = new SearchUserListReq();
        searchUserListReq.setRoleIds(new ArrayList<>());
        if(roleIds!=null) {
        	searchUserListReq.getRoleIds().addAll(roleIds);
        }
        if(roleIds==null||!roleIds.contains(ROLE_ID)) {
        	searchUserListReq.getRoleIds().add(ROLE_ID);
        }
        List<UserListRes> userList = firstArticleMapper.getUserList(searchUserListReq);
        
        return userList;
    }

    @Override
    public ResponseBean<FileRes> exportFaCheckRecordList(SearchFaCheckRecordListReq req) {
        Long bentelerPlanId = req.getBentelerPlanId();
        BentelerPlan plan = planService.getById(bentelerPlanId);

        List<FirstArticleWorkshop> firstArticleWorkshopList = getFaCheckRecordList(req).getData().getFirstArticleWorkshopList();
        FirstArticleTitle title = getFaTitle(bentelerPlanId);
        Map<String, String> titleMap = Convert.toMap(String.class, String.class, title);
        titleMap.put("title", plan.getName());
        List<FaCalendarRes> faCalendarList = getFaCalendarList(SearchFaCalendarReq.builder().checkDate(req.getCheckDate()).bentelerPlanId(bentelerPlanId).build());
        titleMap.put("iniCheckData", faCalendarList.stream().filter(item2 -> item2.getTypeFlag().equals(0)).findFirst().map(item3 -> item3.getTaskTime() != null ? item3.getTaskTime().format(DateTimeFormatter.ofPattern("yyyy年MM月dd日")) : "无").orElse("无"));
        titleMap.put("twoCheckData", faCalendarList.stream().filter(item2 -> item2.getTypeFlag().equals(1)).findFirst().map(item3 -> item3.getTaskTime() != null ? item3.getTaskTime().format(DateTimeFormatter.ofPattern("yyyy年MM月dd日")) : "无").orElse("无"));
        titleMap.put("breakCheckData", faCalendarList.stream().filter(item2 -> item2.getTypeFlag().equals(2)).findFirst().map(item3 -> item3.getTaskTime() != null ? item3.getTaskTime().format(DateTimeFormatter.ofPattern("yyyy年MM月dd日")) : "无").orElse("无"));
        titleMap.put("iniCheckPrinciple", faCalendarList.stream().filter(item2 -> item2.getTypeFlag().equals(0)).findFirst().map(item3 -> item3.getCheckPerson()).orElse("无"));
        titleMap.put("twoCheckPrinciple", faCalendarList.stream().filter(item2 -> item2.getTypeFlag().equals(1)).findFirst().map(item3 -> item3.getCheckPerson()).orElse("无"));
        titleMap.put("breakCheckPrinciple", faCalendarList.stream().filter(item2 -> item2.getTypeFlag().equals(2)).findFirst().map(item3 -> item3.getCheckPerson()).orElse("无"));
        AtomicReference<String> remarkStr = new AtomicReference<>();

        ArrayList<Map<String, String>> arrayList = new ArrayList<>();

        AtomicInteger id = new AtomicInteger(1);
        //返回工作站结果
        firstArticleWorkshopList.forEach(item -> {
            Map<String, String> workMap = Convert.toMap(String.class, String.class, item);
            workMap.remove("firstArticleItemList");
            workMap.remove("allCheckFlag");
            workMap.remove("id");

            //返回巡检结果
            item.getFirstArticleItemList().forEach(item1 -> {

                Map<String, String> beanMap = Convert.toMap(String.class, String.class, item1);
                List<Integer> worksNumList = IntStream.rangeClosed(item1.getSnoStart(), item1.getSnoEnd()).boxed().collect(Collectors.toList());
                workMap.forEach((key, value) -> {
                    if (value != null) {
                        beanMap.merge(key, value, (v1, v2) -> v1);
                    }
                });

                List<String> frequencyList = new ArrayList<>();
                boolean numType = item1.getValFlag().equals(0);
                //检验方法
                String greadScope = numType ? item1.getSnoStart().toString() + "Nm - " + item1.getSnoEnd().toString() + "Nm" : "OK/NoK";
                beanMap.put("scop", greadScope);
                //首件分数
                if (item1.getFirstFlag().equals(1)) {
                    frequencyList.add("首件");
                    Map<Integer, List<FirstArticleItemResult>> fisWorkMap = item1.getFirstItemResultList().stream().collect(Collectors.groupingBy(FirstArticleItemResult::getSno));
                    String greads = worksNumList.stream().map(work -> {
                        return fisWorkMap.get(work) != null ? fisWorkMap.get(work).stream().map(result -> {//检查结果
                            //所有工位订单号相同  其实取一次就可以
                            beanMap.put("firOrder", Optional.ofNullable(result.getOrderNumber()).orElse(null));
                            remarkStr.set(result.getToolDesc());
                            if (numType) {
                                return result.getVal();
                            } else {
                                return result.getValDesc();
                            }
                        }).findFirst().orElse("未填写") : "未填写";
                    }).collect(Collectors.joining(","));
                    beanMap.put("inigread", greads);
                } else {
                    beanMap.put("inigread", "------未要求检测------");
                }
                //200分数
                if (item1.getTwoHundredFlag().equals(1)) {
                    frequencyList.add("200件");
                    Map<Integer, List<FirstArticleItemResult>> fisWorkMap = item1.getTwoHundredItemResultList().stream().collect(Collectors.groupingBy(FirstArticleItemResult::getSno));
                    String greads = worksNumList.stream().map(work -> {
                        return fisWorkMap.get(work) != null ? fisWorkMap.get(work).stream().map(result -> {
                            //所有工位订单号相同  其实取一次就可以
                            beanMap.put("towOrder", Optional.ofNullable(result.getOrderNumber()).orElse(null));
                            if (numType) {
                                return result.getVal();
                            } else {
                                return result.getValDesc();
                            }
                        }).findFirst().orElse("未填写") : "未填写";
                    }).collect(Collectors.joining(","));
                    beanMap.put("twoGread", greads);
                } else {
                    beanMap.put("twoGread", "------未要求检测------");
                }
                //中断分数
                if (item1.getCatchFlag().equals(1)) {
                    frequencyList.add("中断");
                    Map<Integer, List<FirstArticleItemResult>> fisWorkMap = item1.getCatchItemResultList().stream().collect(Collectors.groupingBy(FirstArticleItemResult::getSno));
                    String greads = worksNumList.stream().map(work -> {
                        return fisWorkMap.get(work) != null ? fisWorkMap.get(work).stream().map(result -> {
                            //所有工位订单号相同  其实取一次就可以
                            beanMap.put("breOrder", Optional.ofNullable(result.getOrderNumber()).orElse(null));
                            if (numType) {
                                return result.getVal();
                            } else {
                                return result.getValDesc();
                            }
                        }).findFirst().orElse("未填写") : "未填写";
                    }).collect(Collectors.joining(","));
                    beanMap.put("breakOffgread", greads);
                } else {
                    beanMap.put("breakOffgread", "------未要求检测------");
                }
                String collect = Stream.of(frequencyList.toArray(new String[frequencyList.size()])).collect(Collectors.joining("&"));
                //频率 首件&200&中断
                beanMap.put("frequency", collect);
                //放行记录
                if (item1.getPermitDesc() != null && item1.getPermitDesc().size() > 0) {
                    String permit = item1.getPermitDesc().stream().map(item2 -> {
                        return
                                Optional.ofNullable(item2.getApprovalUserName()).orElse("") + " " +
                                        Optional.ofNullable(item2.getUpdatedTime()).map(item3 -> item2.getUpdatedTime().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"))).orElse("") + " " +
                                        Optional.ofNullable(item2.getReason()).orElse("");
                    }).collect(Collectors.joining("\r\n"));
                    beanMap.put("permit", permit);
                } else {
                    beanMap.put("permit", " ");
                }
                //工具
                beanMap.put("tool", item1.getToolId().equals("-1") ? "非工具校验" : item1.getToolId() + item1.getToolDesc());
                //序号 1-n
                beanMap.put("id", String.valueOf(id.get()));
                id.getAndIncrement();
                arrayList.add(beanMap);
            });


        });
        titleMap.put("remark", remarkStr.get());
        // 模板注意 用{} 来表示你要用的变量 如果本来就有"{","}" 特殊字符 用"\{","\}"代替
        String templateFileName = "systemLib/template/首件计划表.xlsx";
        File tempFile = null;
        ExcelWriter excelWriter = null;
        try {
            // 模板文件
            tempFile = File.createTempFile("shoujian", ".xlsx");

            // 这里 会填充到第一个sheet， 然后文件流会自动关闭
            //设置识别自动换行
            excelWriter = EasyExcel.write(tempFile).withTemplate(templateFileName).registerWriteHandler(new AbstractMergeStrategy() {
                @Override
                protected void merge(Sheet sheet, Cell cell, Head head, Integer relativeRowIndex) {
                    if (cell.getColumnIndex() >= 4) {
                        // 设置自动换行
                        cell.getCellStyle().setWrapText(true);
                    }
                }
            }).build();


            WriteSheet writeSheet = EasyExcel.writerSheet("首件")
                    .registerWriteHandler(new MyHandler()).build();
            //新一行
            FillConfig fillConfig = FillConfig.builder().forceNewRow(Boolean.TRUE).build();

            excelWriter.fill(titleMap, writeSheet);
            excelWriter.fill(arrayList, fillConfig, writeSheet);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            excelWriter.finish();
        }
        return commonService.exportExcel(tempFile);
    }

    @Override
    public ResponseBean<FileRes> exportInitialPlanDetails(ExportInitialPlanDetailsReq req) {

        Long bentelerPlanId = req.getIniPlnaId();
        BentelerPlan plan = planService.getById(bentelerPlanId);

        List<FirstArticleWorkshop> firstArticleWorkshopList = firstArticleWorkshopService.list(Wrappers.<FirstArticleWorkshop>lambdaQuery()
                .eq(FirstArticleWorkshop::getBentelerPlanId, req.getIniPlnaId()));
        for (FirstArticleWorkshop firstArticleWorkshop : firstArticleWorkshopList) {
            List<FirstArticleItem> firstArticleItemList = firstArticleItemService.list(Wrappers.<FirstArticleItem>lambdaQuery()
                    .eq(FirstArticleItem::getWorkshopId, firstArticleWorkshop.getId()));


            firstArticleWorkshop.setFirstArticleItemList(firstArticleItemList);
        }
        FirstArticleTitle title = getFaTitle(bentelerPlanId);
        Map<String, String> titleMap = Convert.toMap(String.class, String.class, title);
        titleMap.put("title", plan.getName());


        ArrayList<Map<String, String>> arrayList = new ArrayList<>();
        AtomicInteger id = new AtomicInteger(1);
        //返回工作站结果
        firstArticleWorkshopList.forEach(item -> {
            Map<String, String> workMap = Convert.toMap(String.class, String.class, item);
            workMap.remove("firstArticleItemList");
            workMap.remove("allCheckFlag");
            workMap.remove("id");
            //返回巡检结果
            item.getFirstArticleItemList().forEach(item1 -> {

                Map<String, String> beanMap = Convert.toMap(String.class, String.class, item1);
                List<Integer> worksNumList = IntStream.rangeClosed(item1.getSnoStart(), item1.getSnoEnd()).boxed().collect(Collectors.toList());
                workMap.forEach((key, value) -> {
                    if (value != null) {
                        beanMap.merge(key, value, (v1, v2) -> v1);
                    }
                });
                List<String> frequencyList = new ArrayList<>();
                if (item1.getFirstFlag().equals(1)) {
                    frequencyList.add("首件");
                }
                if (item1.getTwoHundredFlag().equals(1)) {
                    frequencyList.add("200件");
                }
                if (item1.getCatchFlag().equals(1)) {
                    frequencyList.add("中断");
                }
                boolean numType = item1.getValFlag().equals(0);
                String greadScope = numType ? item1.getSnoStart().toString() + "Nm - " + item1.getSnoEnd().toString() + "Nm" : "OK/NoK";
                beanMap.put("scop", greadScope);

                String frequency = Stream.of(frequencyList.toArray(new String[frequencyList.size()])).collect(Collectors.joining("&"));
                beanMap.put("frequency", frequency);
                beanMap.put("toolDesc", "");
                beanMap.put("tool", item1.getToolId().equals("-1") ? "非工具校验" : item1.getToolId() + item1.getToolDesc());
                beanMap.put("id", String.valueOf(id.get()));
                id.getAndIncrement();
                arrayList.add(beanMap);

            });


        });

        // 模板注意 用{} 来表示你要用的变量 如果本来就有"{","}" 特殊字符 用"\{","\}"代替
        String templateFileName = "systemLib/template/首件计划受控文件.xlsx";
        File tempFile = null;
        ExcelWriter excelWriter = null;
        try {
            // 模板文件
            tempFile = File.createTempFile("shoujian", ".xlsx");

            // 这里 会填充到第一个sheet， 然后文件流会自动关闭
            excelWriter = EasyExcel.write(tempFile).withTemplate(templateFileName).build();


            WriteSheet writeSheet = EasyExcel.writerSheet("首件")
                    .registerWriteHandler(new MyHandler()).build();
            //新一行
            FillConfig fillConfig = FillConfig.builder().forceNewRow(Boolean.TRUE).build();

            excelWriter.fill(titleMap, writeSheet);
            excelWriter.fill(arrayList, fillConfig, writeSheet);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            excelWriter.finish();
        }
        return commonService.exportExcel(tempFile);
    }

    /**
     * 取得点检人
     *
     * @param req
     * @return 点检人
     */
    @Override
    public List<FaCalendarRes> getFaCalendarList(SearchFaCalendarReq req) {
        List<FaCalendarRes> faCalendarList = firstArticleMapper.getFaCalendarList(req);
        if (faCalendarList.stream().noneMatch(item -> item.getTypeFlag().equals(0))) {
            faCalendarList.add(FaCalendarRes.builder().typeFlag(0).build());
        }
        if (faCalendarList.stream().noneMatch(item -> item.getTypeFlag().equals(1))) {
            faCalendarList.add(FaCalendarRes.builder().typeFlag(1).build());
        }
        if (faCalendarList.stream().noneMatch(item -> item.getTypeFlag().equals(2))) {
            faCalendarList.add(FaCalendarRes.builder().typeFlag(2).build());
        }
        return faCalendarList;
    }


    /**
     * task二级审批不通过的，即为重检，此时将点检结果item_result为不通过的1都改成成-1，这样重检时相当于重新开始，没有之前首次点检的结果
     *
     * @param firstArticleTaskId
     * @return
     */
    @Override
    public void setFaRepeatResult(long firstArticleTaskId) {
        LambdaUpdateWrapper<FirstArticleItemResult> lambdaUpdateWrapper = new LambdaUpdateWrapper<>();
        lambdaUpdateWrapper.eq(FirstArticleItemResult::getFirstArticleTaskId, firstArticleTaskId)
                .eq(FirstArticleItemResult::getResult, 1)
                .set(FirstArticleItemResult::getResult, -1);
        firstArticleItemResultService.update(lambdaUpdateWrapper);
    }


    @Override
	public List<FaTaskResForPad> getFaBreakTaskForPad(SearchFaWorkshopListForPadReq req) {
    	List<FaTaskResForPad> listRes = firstArticleMapper.getFaBreakTaskForPad(req);
		return listRes;
	}


	/**
     * Object转成byte[]
     *
     * @param obj
     * @return byte[]
     */
    private byte[] objectToByteArray(Object obj) throws Exception {
        byte[] bytes = null;
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        ObjectOutputStream oos = new ObjectOutputStream(baos);
        oos.writeObject(obj);
        oos.close();
        bytes = baos.toByteArray();
        baos.close();
        return bytes;
    }

    /**
     * byte[]转成Object
     *
     * @param @byte[]
     * @return Object
     */
    private Object byteArrayToObject(byte[] buffer) throws Exception {
        Object ob = null;
        ObjectInputStream ois = new ObjectInputStream(new ByteArrayInputStream(buffer));
        ob = ois.readObject();
        ois.close();
        return ob;
    }

}
