package com.factory.web.service.impl.onsite;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.factory.base.entity.aggregates.PageBean;
import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.util.res.ResponseBeanBuilder;
import com.factory.web.entity.onsite.OnsiteItem2;
import com.factory.web.entity.onsite.OnsiteItemReq;
import com.factory.web.entity.onsite.OnsiteItemRes;
import com.factory.web.mapper.onsite.OnsiteItemMapper2;
import com.factory.web.service.onsite.OnsiteItemService2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.function.Function;

/**
 * 巡检项目设置
 *
 * @author wzy
 * @date 2021-07-06 12:10:10
 */
@Service("onsiteItemService2")
@Transactional(rollbackFor = Exception.class)
public class OnsiteItemService2Impl extends ServiceImpl<OnsiteItemMapper2, OnsiteItem2> implements OnsiteItemService2 {

    @Autowired
    private OnsiteItemMapper2 onsiteItemMapper2;

    /**
     * 取得巡检项目列表
     *
     * @param req
     * @return 巡检项目列表
     */
    public ResponseBean<PageBean<OnsiteItemRes>> getList(OnsiteItemReq req) {
        Page<OnsiteItemRes> page = new Page<>(req.getPage(), req.getSize());
        Page<OnsiteItemRes> listResPage = onsiteItemMapper2.getList(page, req);
        return ResponseBeanBuilder.ok(listResPage, Function.identity());
    }
}