package com.factory.web.service.impl.pm;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.factory.web.entity.pm.ApprovalRule;
import com.factory.web.entity.pm.OnsiteApprovalPlan;
import com.factory.web.mapper.pm.ApprovalRuleMapper;
import com.factory.web.mapper.pm.OnsiteApprovalPlanMapper;
import com.factory.web.service.pm.OnsiteApprovalPlanService;


/**
 * 计划审批
 *
 * @author wzy
 * @date 2021-07-09 12:00:00
 */
@Service("onsiteApprovalPlanService")
@Transactional(rollbackFor = Exception.class)
public class OnsiteApprovalPlanServiceImpl extends ServiceImpl<OnsiteApprovalPlanMapper, OnsiteApprovalPlan> implements OnsiteApprovalPlanService {
	
	@Autowired
	private ApprovalRuleMapper approvalRuleMapper;
	
	/**
	 * 第一级待审核计划
	 * 是否清空之前的审核记录
	 */
	@Override
	public void setApprovalFirst(Long planId,boolean clearApproval) {
		if(clearApproval) {
			this.remove(Wrappers.<OnsiteApprovalPlan>lambdaQuery()
                    .eq(OnsiteApprovalPlan::getBentelerPlanId, planId));
		}
		ApprovalRule approvalRuleMinLevel = approvalRuleMapper.selectOne(Wrappers.<ApprovalRule>lambdaQuery()
				.eq(ApprovalRule::getType, ApprovalRule.APPROVAL_TYPE_NEW)
				.orderByAsc(ApprovalRule::getApprovalLevel)
				.last("limit 1"));
		if (approvalRuleMinLevel != null) {
			/* 添加计划一级审批 */
			OnsiteApprovalPlan onsiteApprovalPlan = OnsiteApprovalPlan.builder()
					.bentelerPlanId(planId)
					.approvalLevel(approvalRuleMinLevel.getApprovalLevel()) // 1级审批
					.approvalRole(approvalRuleMinLevel.getRoleId())
					.status(0) // 0未审批
					.build();
			this.save(onsiteApprovalPlan);
//			向下一级别发送提醒
//			Date date = new Date();
//			SimpleDateFormat ft = new SimpleDateFormat("yyyy-MM-dd");
//			//发送微信消息
//			wxService.sendWechatMessage(SendMsgReq.builder()
//					.toUserId(approvalUserRes.getUserId())
//					.title("计划审批提醒")
//					.content("您有待审批的新建计划，请登录小程序查看【计划审批】")
//					.endTime(ft.format(date))
//					.fromUserId(plan.getCreatedUserId())
//					.build());
		}
	}
}