package com.factory.web.service.ini;

import com.baomidou.mybatisplus.extension.service.IService;
import com.factory.base.entity.aggregates.PageBean;
import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.entity.enumPo.ReviewStatus;
import com.factory.base.entity.po.benteler.*;
import com.factory.base.entity.vo.req.BaseIdReq;
import com.factory.base.entity.vo.req.BasePageIdReq;
import com.factory.base.entity.vo.req.BaseTypeReq;
import com.factory.user.entity.vo.res.FileRes;
import com.factory.web.entity.vo.req.pad.submitCheckReq;
import com.factory.web.entity.vo.req.pad.workDetailsReq;
import com.factory.web.entity.vo.req.web.*;
import com.factory.web.entity.vo.res.pad.ini.abnormalListRes;
import com.factory.web.entity.vo.res.pad.ini.planlistRes;
import com.factory.web.entity.vo.res.pad.ini.workDetailsRes;
import com.factory.web.entity.vo.res.pad.ini.workTypeDetailsRes;
import com.factory.web.entity.vo.res.web.ini.*;

import java.time.LocalDate;
import java.util.List;

/**
 * 计划 - 版本信息
 *
 * @author chenshun
 * @email sunlightcs@gmail.com
 * @date 2021-06-26 12:35:17
 */
public interface BentelerIniVersionService extends IService<BentelerIniVersion> {

    ResponseBean<PageBean<PagePlanRes>> pagePlan_web(PlanListReq req);

    ResponseBean addIniPlan(AddIniPlanReq req);

    ResponseBean disablePlan(BooleanReq req);

    ResponseBean<PageBean<unAuditListRes>> unAuditList(PlanListReq req);

    ResponseBean<GetVersionBaseRes> getVersionBase(BaseIdReq req);

    ResponseBean<AddIniPlanReq> getUnAuditDetails(BaseIdReq req);

    ResponseBean<AddIniPlanReq> getCurrentDetails(BaseIdReq req);

    ResponseBean addIniVersion(AddIniPlanReq req);

    ResponseBean<Boolean> getIsUnAuditVersionId(BaseIdReq req);

    ResponseBean<PageBean<GetVersionHistoryRes>> historyVersion(BasePageIdReq req);

    ResponseBean<planlistRes> planlist_pad();

    ResponseBean<List<workDetailsRes>> workDetails(BaseTypeReq req);

    ResponseBean<workTypeDetailsRes> workTypeDetails(workDetailsReq req);

    ResponseBean saveCheckItem(workTypeDetailsRes req);

    ResponseBean submitCheck(submitCheckReq req);

    BentelerIniCheckType getResult_checkType(Long resultId, Integer checkType, LocalDate now);

    void assemblerVersionItem_checkItem(List<BentelerIniVersionItem> versionItems, Integer checkType, LocalDate now);

    void assemblerCheckItem_iniGread(List<BentelerIniCheckItem> checkItems);

    BentelerPlan planReq2planPo(AddIniPlanReq req, ReviewStatus reviewStatus);

    AddIniPlanReq planPo2planReq(BentelerPlan plan);

    boolean planNameRepetition(String name);

    ResponseBean<FileRes> exportInitialPlan(ExportInitialPlanReq req);

    List<getCheckResutGreadRes> getCheckResutGread(getCheckResutGreadReq req);

    ResponseBean<List<abnormalListRes>> abnormalList();

    ResponseBean<List<BentelerIniWorkstation>> abnormalWorkGroup(BaseTypeReq id);

}

