package com.factory.wx.entity.res;

import com.factory.web.entity.fa.FirstArticleTitle;
import com.factory.web.entity.pm.OnsiteTitle;
import com.factory.web.entity.pm.res.AbnormalTaskInfoRes;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDate;
import java.util.List;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-29 3:08 下午
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class AbnormalDetailRes {
    @ApiModelProperty(value = "计划Id")
    private Long planId;
    @ApiModelProperty(value = "计划名称")
    private String planName;
    @ApiModelProperty(value = "计划类型")
    private Integer planType;
    @ApiModelProperty(value = "检验负责人")
    private List<String> usersName;
    @ApiModelProperty(value = "计划生效日期")
    private LocalDate effectiveDate;
    @ApiModelProperty(value = "检验频次")
    private List<Integer> frequency;
    @ApiModelProperty(value = "是否有附件 0无附件 1有附件")
    private int attachment;

    @ApiModelProperty(value = "防错表头信息")
    private OnsiteTitle titleInfo;

    @ApiModelProperty(value = "表头信息-首件")
    private FirstArticleTitle firstArticleTitle;
    @ApiModelProperty(value = "任务信息-首件")
    private List<AbnormalTaskInfoRes> abnormalTaskInfos;
}
