package com.factory.wx.entity.res;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class PlanPassItemRes implements Serializable {

    @ApiModelProperty(value = "巡检项目id")
    private Long itemId;

    @ApiModelProperty(value = "巡检项目内容")
    private String itemContent;

    @ApiModelProperty(value = "巡检类型")
    private int itemType;

    @ApiModelProperty(value = "防错检查结果：0通过 1巡检不通过 2没有巡检")
    private Integer result;

    @ApiModelProperty(value = "防错异常信息")
    private String abnormal;

    @ApiModelProperty(value = "判断标准")
    private String itemStandard;

    @ApiModelProperty(value = "点检时间")
    private String itemResultCreateTime;

    @ApiModelProperty(value = "点检人id")
    private Long itemResultUserId;

    @ApiModelProperty(value = "点检人")
    private String itemResultUser;

    @ApiModelProperty(value = "测量点前缀")
    private String prefix;

    @ApiModelProperty(value = "测量点序号开始")
    private Integer snoStart;

    @ApiModelProperty(value = "测量点序号结束")
    private Integer snoEnd;

    @ApiModelProperty(value = "数据类型 0数值 1属性")
    private Integer valFlag;

    @ApiModelProperty(value = "上限 对应数据类型0数值")
    private Double valUp;

    @ApiModelProperty(value = "下限 对应数据类型0数值")
    private Double valDown;

    @ApiModelProperty(value = "单位 对应数据类型0数值")
    private String valUnit;

    @ApiModelProperty(value = "0表示ok 1表示nook 对应数据类型1属性")
    private Integer valOk;

    @ApiModelProperty(value = "描述 对应数据类型1属性")
    private String valDesc;

    @ApiModelProperty(value = "特性等级")
    private String levelInfo;

    @ApiModelProperty(value = "产品特性")
    private String productInfo;

    @ApiModelProperty(value = "检验工具id")
    private String toolId;

    @ApiModelProperty(value = "检验工具描述")
    private String toolDesc;

    @ApiModelProperty(value = "检验频次首件 0没选择 1选择")
    private Integer firstFlag;

    @ApiModelProperty(value = "检验频次200件 0没选择 1选择")
    private Integer twoHundredFlag;

    @ApiModelProperty(value = "检验频次中断 0没选择 1选择")
    private Integer catchFlag;

    @ApiModelProperty(value = "首件检查结果")
    private List<PlanPassItemResultRes> firstItemResultList; // 用于页面返回值

    @ApiModelProperty(value = "200件检查结果")
    private List<PlanPassItemResultRes> twoHundredItemResultList; // 用于页面返回值

    @ApiModelProperty(value = "中断检查结果")
    private List<PlanPassItemResultRes> catchItemResultList; // 用于页面返回值

}
