package com.factory.wx.entity.res;

import com.factory.web.entity.fa.FirstArticleTitle;
import com.factory.web.entity.fa.FirstArticleWorkshop;
import com.factory.web.entity.pm.OnsiteTitle;
import com.factory.web.entity.pm.OnsiteWorkshop;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDate;
import java.util.List;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-15 11:02 上午
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class PlanReminderDetailRes {
    @ApiModelProperty(value = "计划Id")
    private Long planId;
    @ApiModelProperty(value = "计划名称")
    private String planName;
    @ApiModelProperty(value = "检验负责人")
    private List<String> usersName;
    @ApiModelProperty(value = "计划生效日期")
    private LocalDate effectiveDate;
    @ApiModelProperty(value = "检验频次")
    private List<Integer> frequency;
    @ApiModelProperty(value = "是否有附件 0无附件 1有附件")
    private int attachment;

    @ApiModelProperty(value = "表头信息")
    private OnsiteTitle titleInfo;
    @ApiModelProperty(value = "防错计划工作站点检")
    private List<OnsiteWorkshop> onsiteWorkshops;

    @ApiModelProperty(value = "表头信息-首件")
    private FirstArticleTitle firstArticleTitle;
    @ApiModelProperty(value = "首件计划基本信息")
    private List<FirstArticleWorkshop> firstArticleWorkshops;
}
