package com.factory.wx.entity.res;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDate;
import java.util.List;

/**
 * 微信端返回计划基础信息
 *
 * @author sMArT
 * @version 1.0
 * @date 2021-07-29 9:49 上午
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class WxPlanBaseInfoRes {
    @ApiModelProperty(value = "计划Id")
    private Long planId;
    @ApiModelProperty(value = "计划名称")
    private String planName;
    @ApiModelProperty(value = "检验负责人")
    private List<String> usersName;
    @ApiModelProperty(value = "计划生效日期")
    private LocalDate effectiveDate;
    @ApiModelProperty(value = "检验频次")
    private List<Integer> frequency;
    @ApiModelProperty(value = "表头信息")
    private Object title;
    @ApiModelProperty(value = "是否有附件 0无附件 1有附件")
    private int attachment;


}
