package com.factory.wx.mapper;

import com.factory.web.entity.pm.req.SearchAbnormalReq;
import com.factory.web.entity.pm.res.AbnormalItemRes;
import com.factory.web.entity.pm.res.AbnormalTaskInfoRes;
import com.factory.wx.entity.req.AbnormalPlanReq;
import com.factory.wx.entity.res.AbnormalPlanRes;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-23 2:09 上午
 */
@Mapper
public interface AbnormalStatisticsMapper {
    /**
     * 获取放行异常计划
     *
     * @return
     */
    List<AbnormalPlanRes> getReleasedAbnormalPlans(AbnormalPlanReq abnormalPlanReq);

    /**
     * 获取重检异常计划
     *
     * @param abnormalPlanReq
     * @return
     */
    List<AbnormalPlanRes> getRecheckedAbnormalPlans(AbnormalPlanReq abnormalPlanReq);

    /**
     * 根据计划id获取首件放行
     *
     * @param planId
     * @return
     */
    List<AbnormalTaskInfoRes> getFaReleaseListByPlanId(@Param("planId") Long planId,@Param("taskId") Long taskId);

    /**
     * 根据计划id获取防错放行
     *
     * @param planId
     * @return
     */
    List<AbnormalTaskInfoRes> getPmReleaseListByPlanId(@Param("planId") Long planId,@Param("taskId") Long taskId);

    /**
     * 根据计划id获取首件重检
     *
     * @param planId
     * @return
     */
    List<AbnormalTaskInfoRes> getFaRecheckedListByPlanId(@Param("planId") Long planId,@Param("taskId") Long taskId);

    /**
     * 根据计划id获取防错重检
     *
     * @param planId
     * @return
     */
    List<AbnormalTaskInfoRes> getPmRecheckedListByPlanId(@Param("planId") Long planId,@Param("taskId") Long taskId);

    List<AbnormalItemRes> getPmAbnormalItemResultList(@Param("req") SearchAbnormalReq searchReq);

    List<AbnormalItemRes> getFaAbnormalItemResultList(@Param("req") SearchAbnormalReq searchReq);
}
