package com.factory.wx.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.factory.wx.entity.req.PlanPageReq;
import com.factory.wx.entity.req.PlanPassReq;
import com.factory.wx.entity.req.SearchPlanPassReq;
import com.factory.wx.entity.res.PlanPassItemRes;
import com.factory.wx.entity.res.PlanPassItemResultRes;
import com.factory.wx.entity.res.PlanPassRes;
import com.factory.wx.entity.res.PlanPassTaskRes;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-20 11:22 上午
 */
@Mapper
public interface PlanPassMapper {
    /**
     * 获取放行列表-首件
     *
     * @param planPageReq
     * @return
     */
    List<PlanPassRes> getPlanPassList(@Param("page") IPage<PlanPassRes> page,@Param("req") PlanPageReq planPageReq);

    /**
     * 获取放行列表-防错
     *
     * @param planPageReq
     * @return
     */
    List<PlanPassRes> getPlanPassPMList(@Param("page") IPage<PlanPassRes> page,@Param("req") PlanPageReq planPageReq);

//    /**
//     * 获取待放行任务-首件
//     *
//     * @param userId
//     * @return
//     */
//    List<FirstArticleApprovalTask> getFirstArticleApprovalTaskList(Long userId);

    /**
     * 获取待放行防错任务
     *
     * @param planPassReq
     * @return
     */
    List<PlanPassTaskRes> getPmPassTaskListByPlanId(@Param("req") PlanPassReq planPassReq);


    /**
     * 获取检测点信息
     *
     * @param req
     * @return
     */
    List<PlanPassItemRes> getPmPassItemList(@Param("req") SearchPlanPassReq req);

    /**
     * 获取待放行首件任务
     *
     * @param planPassReq
     * @return
     */
    List<PlanPassTaskRes> getFaPassTaskListByPlanId(@Param("req") PlanPassReq planPassReq);

    /**
     * 获取首件监测点信息
     *
     * @param req
     * @return
     */
    List<PlanPassItemRes> getFaPassItemList(@Param("req") SearchPlanPassReq req);

    /**
     * 获取首件检测结果
     *
     * @param searchReq
     * @return
     */
    List<PlanPassItemResultRes> getFaPassItemResultList(@Param("req") SearchPlanPassReq searchReq);

}
