package com.factory.wx.service;

import com.factory.base.entity.aggregates.PageBean;
import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.entity.po.benteler.BentelerPlan;
import com.factory.wx.entity.req.PlanApprovalReq;
import com.factory.wx.entity.req.PlanInfoReq;
import com.factory.wx.entity.req.PlanPageReq;
import com.factory.wx.entity.res.PlanApprovalDetailRes;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-13 12:13 下午
 */
public interface PlanApprovalService {

    /**
     * 分页显示计划列表
     *
     * @param planPageReq
     * @return
     */
    PageBean<BentelerPlan> getApprovalListByPage(PlanPageReq planPageReq);


    /**
     * 获取首件审批计划详情
     *
     * @param planInfoReq
     * @return
     */
    PlanApprovalDetailRes getApprovalFADetail(PlanInfoReq planInfoReq);

    /**
     * 获取防错审批计划详情
     *
     * @param planInfoReq
     * @return
     */
    PlanApprovalDetailRes getApprovalPMDetail(PlanInfoReq planInfoReq);

    /**
     * 计划审批
     *
     * @param planApprovalReq
     * @return
     */
    ResponseBean<Void> approvalOperate(PlanApprovalReq planApprovalReq);
}
