package com.factory.wx.service;

import com.factory.wx.entity.req.PlanInfoReq;
import com.factory.wx.entity.req.PlanPageReq;
import com.factory.wx.entity.res.PlanReminderDetailRes;
import com.factory.wx.entity.res.ReminderRes;

import java.util.List;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-13 12:13 下午
 */
public interface PlanReminderService {

    /**
     * 获得计划提醒列表
     *
     * @param planPageReq
     * @return
     */
    List<ReminderRes> getReminderList(PlanPageReq planPageReq);

    /**
     * 防错计划提醒详情
     *
     * @param planInfoReq
     * @return
     */
    PlanReminderDetailRes getReminderDetailPM(PlanInfoReq planInfoReq);

    /**
     * 确认已提醒
     *
     * @param planInfoReq
     */
    int confirmReminder(PlanInfoReq planInfoReq);

    /**
     * 首件计划提醒详情
     *
     * @param planInfoReq
     * @return
     */
    PlanReminderDetailRes getReminderDetail(PlanInfoReq planInfoReq);
}
