package com.factory.wx.service;

import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.wx.entity.req.SendMsgReq;
import com.factory.wx.entity.res.FunctionsRes;

import java.util.List;

/**
 * 微信基础功能service
 *
 * @author sMArT
 * @version 1.0
 * @date 2021-07-12 3:27 下午
 */
public interface WxService {
    ResponseBean<List<FunctionsRes>> getUserFunction(Long userId);

    /**
     * 绑定微信用户
     *
     * @param code
     * @param userId
     */
    ResponseBean bindWeChatUser(String code, Long userId);

    /**
     * 查询用户是否绑定
     *
     * @param openid
     * @param userId
     * @return
     */
    Integer selectBindWeChatUserCount(String openid, Long userId);

    /**
     * 给微信用户发送消息
     *
     * @param sendMsgReq
     */
    void sendWechatMessage(SendMsgReq sendMsgReq);
    /**
     * 按照角色批量发送
     * @param sendMsgReq
     * @param roleId
     */
    void sendWechatMessageByRole(SendMsgReq sendMsgReq,Long roleId);
}
