package com.factory.file.config;


import com.factory.base.entity.constant.SystemConstant;
import com.factory.base.config.properties.FileSystemProperties;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import javax.annotation.Resource;
import java.io.File;
import java.io.IOException;

@Configuration
@Slf4j
public class WebMvcConfig implements WebMvcConfigurer {

    @Resource
    private FileSystemProperties fileSystemProperties;

    @Override
    public void addResourceHandlers(ResourceHandlerRegistry registry) {
        File file = new File("");
        String canonicalPath = "";
        try {
            canonicalPath = file.getCanonicalPath();

        } catch (IOException e) {
            e.printStackTrace();
        }
        log.info("init download dir:{}", canonicalPath);
        registry
                .addResourceHandler(
                        StringUtils.join(
                                SystemConstant.URI_CONCAT_SYMBOL,
                                fileSystemProperties.getFileStoreDir(),
                                SystemConstant.URI_CONCAT_SYMBOL,
                                SystemConstant.URI_FULL_PATTERN_SYMBOL
                        )
                ).addResourceLocations(
                        StringUtils.join(
                                SystemConstant.WEB_MVC_STATIC_RESOURCE_MAPPING_PREFIX,
                                canonicalPath,
                                SystemConstant.URI_CONCAT_SYMBOL,
                                fileSystemProperties.getFileStoreDir(),
                                SystemConstant.URI_CONCAT_SYMBOL
                        ));
    }
}
