package com.factory.init;

import java.time.LocalDate;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import com.factory.service.PlanService;

/**
 * 计划生效定时器
 * @author edz
 *
 */
@Component
public class PlanScheduleService {

	@Autowired
	private PlanService planService;
	
	@Scheduled(cron="30 0/1 * * * ?")
	public void effectPlan() {
		planService.effectPlan(LocalDate.now());
	}
	@Scheduled(cron="${task.first.cron:'0 */5 * * * ?'}")
	public void makeFirstTask() {
		planService.makeFirstTask(LocalDate.now());
	}
	@Scheduled(cron="${task.onsite.cron:'0 */5 * * * ?'}")
	public void makeOnsiteTask() {
		planService.makeOnsiteTask(LocalDate.now());
	}
	
}
