package com.factory.init;

import org.quartz.*;

public class QuartzManager {

    public final static String JOB_GROUP_NAME = "ONSITE_TASK";//纠错任务生成

    public final static String JOB_PARAM_NAME = "jobParam"; //传递参数名称


    /**
     * 给定时器添加任务
     *
     * @param sched
     * @param param
     */
    public static void addJob(Scheduler sched, JobFactoryParam param) {
        try {
            TriggerKey triggerKey = TriggerKey.triggerKey(param.getJobName(), param.getJobGroupName());
            CronTrigger trigger = (CronTrigger) sched.getTrigger(triggerKey);
            if (trigger == null) {
                JobDetail jobDetail = JobBuilder.newJob(param.getClazz()).withIdentity(param.getJobName(), param.getJobGroupName()).build();
                jobDetail.getJobDataMap().put(QuartzManager.JOB_PARAM_NAME, param.getParamMap());  //这个用于Job继承类的context
                CronScheduleBuilder scheduleBuilder = CronScheduleBuilder.cronSchedule(param.getTriggerRule()).withMisfireHandlingInstructionDoNothing();
                trigger = TriggerBuilder.newTrigger().withIdentity(param.getJobName(), param.getJobGroupName()).withSchedule(scheduleBuilder).build();
                sched.scheduleJob(jobDetail, trigger);
            } else {//更新
                CronScheduleBuilder scheduleBuilder = CronScheduleBuilder.cronSchedule(param.getTriggerRule()).withMisfireHandlingInstructionDoNothing();
                ;
                trigger = trigger.getTriggerBuilder().withIdentity(triggerKey).withSchedule(scheduleBuilder).build();
                sched.rescheduleJob(triggerKey, trigger);
            }
            JobKey jobKey = JobKey.jobKey(param.getJobName(), param.getJobGroupName());
            sched.triggerJob(jobKey); //想马上触发打开这个
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }


}
