package com.factory.mapper;


import java.time.LocalDate;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import com.factory.base.entity.task.ApprovalUserRes;
import com.factory.base.entity.task.ApproveEntry;
import com.factory.base.entity.task.FirstCalendar;
import com.factory.base.entity.task.FirstTask;

@Mapper
public interface FirstTaskMapper {


    /**
     * 获取对应的规则
     *
     * @return
     */
    List<FirstCalendar> getCalenderFirstForType(@Param("typeFlag")Integer typeFlag,@Param("date")LocalDate date);


    /**
     * 添加当天任务
     *
     * @param task
     * @return
     */
    int insertFirstTask(FirstTask task);
    /**
     * 添加当天任务
     *
     * @param task
     * @return
     */
    int insertFirstTaskKey(FirstTask task);

    /**
     * 需要提醒的工作
     *
     * @param param
     * @return
     */
    public List<FirstCalendar> getRemindWork(Map<String, Object> param);


    /**
     * 更新提醒状态，不太好的写法但是符合现在的需求
     *
     * @param param
     * @return
     */
    public int updateFirstRemindFlag(Map<String, Object> param);


    /**
     * 添加不工作提醒信息
     *
     * @param map
     * @return
     */
    public int addRemindNowork(Map map);

    /**
     * 获取需要提醒人
     *
     * @param map
     * @return
     */
    public Long getRemindNoworkToManager(Map map);

    /**
     * 获取最大审批级别
     *
     * @param map
     * @return
     */
    public int getMaxApproveLevel(Map map);

    /**
     * 或许超时没处理记录
     *
     * @param map
     * @return
     */
    public List<ApproveEntry> getApproveTaskNoDeal(Map map);

    public int updateApproveTask(ApproveEntry vo);

    public int addApproveTask(ApproveEntry vo);

    public ApprovalUserRes getApprovalNextUser(Map map);
    /**
     * 获取放行的计划基本信息
     * @param taskId
     * @return
     */
    public Map<String,Object> getApprovalPlanInfo(Long taskId);


}
