package com.factory.service;

import java.time.LocalDate;
import java.util.List;
import java.util.Map;

import com.factory.base.entity.task.ApproveEntry;
import com.factory.base.entity.task.FirstCalendar;
import com.factory.base.entity.task.FirstTask;

public interface FirstTaskService {

    /**
     * 获取对应的规则
     *
     * @return
     */
    List<FirstCalendar> getCalenderFirstForType(Integer typeFlag,LocalDate date);

    /**
     * 添加当天任务
     *
     * @param task
     * @return
     */
    int insertFirstTask(FirstTask task);

    /**
     * 需要提醒的工作
     *
     * @param param
     * @return
     */
    List<FirstCalendar> getRemindWork(Map<String, Object> param);


    /**
     * 更新提醒状态，不太好的写法但是符合现在的需求
     *
     * @param param
     * @return
     */
    int updateFirstRemindFlag(Map<String, Object> param);


    /**
     * 添加不工作提醒信息
     *
     * @param map
     * @return
     */
    int addRemindNowork(Map<String, Object> map);

    /**
     * 获取需要提醒人
     *
     * @param map
     * @return
     */
    Long getRemindNoworkToManager(Map<String, Object> map);

    /**
     * 获取最大审批级别
     *
     * @param map
     * @return
     */
    int getMaxApproveLevel(Map<String, Object> map);

    /**
     * 或许超时没处理记录
     *
     * @param map
     * @return
     */
    List<ApproveEntry> getApproveTaskNoDeal(Map<String, Object> map);

    /**
     * 添加新任务处理
     *
     * @param vo
     * @return
     */
    int addTaskForNext(ApproveEntry vo);
    
    
    Map<String,Object> getApprovalPlanInfo(Long taskId);
}
