package com.factory.service;

import com.factory.base.entity.task.ApproveEntry;
import com.factory.base.entity.task.OnsiteCalendar;
import com.factory.base.entity.task.OnsiteTask;

import java.util.List;
import java.util.Map;

public interface OnsiteTaskService {

    public int getTaskExistCount(Map<String,Object> map);

    @Deprecated
    public int delTaskOld(Map<String,Object> map);

    /**
     * 添加不工作提醒信息
     *
     * @param map
     * @return
     */
    public int addRemindNowork(Map<String,Object> map);

    /**
     * 获取需要提醒人
     *
     * @param map
     * @return
     */
    public Long getRemindNoworkToManager(Map<String,Object> map);

    /**
     * 添加当天任务
     *
     * @param task
     * @return
     */
    public int insertOnsiteTask(OnsiteTask task);

    /**
     * 获取对应的规则
     *
     * @param param
     * @return
     */
    public List<OnsiteCalendar> getCalenderOnsitesForType(Map<String, Object> param);


    /**
     * 需要提醒的工作
     *
     * @param param
     * @return
     */
    public List<OnsiteCalendar> getRemindWork(Map<String, Object> param);


    /**
     * 更新提醒状态，不太好的写法但是符合现在的需求
     *
     * @param param
     * @return
     */
    public int updateOnsiteRemindFlag(Map<String, Object> param);

    /**
     * 获取最大审批级别
     *
     * @param map
     * @return
     */
    public int getMaxApproveLevel(Map<String,Object> map);

    /**
     * 或许超时没处理记录
     *
     * @param map
     * @return
     */
    public List<ApproveEntry> getApproveTaskNoDeal(Map<String,Object> map);

    /**
     * 添加新任务处理
     *
     * @param vo
     * @return
     */
    public int addTaskForNext(ApproveEntry vo);
    
    public Map<String,Object> getApprovalPlanInfo(Long taskId);

}
