package com.factory.websocket;

import org.springframework.http.server.ServerHttpRequest;
import org.springframework.http.server.ServerHttpResponse;
import org.springframework.http.server.ServletServerHttpRequest;
import org.springframework.stereotype.Component;
import org.springframework.web.socket.WebSocketHandler;
import org.springframework.web.socket.server.HandshakeInterceptor;

import java.util.Map;

/**
 * 过来过滤安全确定 验证用户身份
 */
@Component
public class WebSocketHandshakeInterceptor implements HandshakeInterceptor {

    @Override
    public boolean beforeHandshake(ServerHttpRequest serverHttpRequest, ServerHttpResponse serverHttpResponse, WebSocketHandler webSocketHandler, Map<String, Object> attributes) throws Exception {

        ServletServerHttpRequest request = (ServletServerHttpRequest) serverHttpRequest;
        String token = request.getServletRequest().getParameter("token"); //目前传userid即可明文
        // des 对userid加密即可也可以是jwt测试先不做 因为pad的提醒都是工作人员，详单与这个部分需要userid，因为需要从这个信息知道这个人是谁，这样我们就可以在token
        // 这样我们就可以在任务提醒中查询后直接用key获取session推送 因为websocket只推送工作人员，所以不需要做区分同意存一个map即可
        if (token != null) {
            attributes.put("token", token);
            return true;
        }
        return false;
    }

    @Override
    public void afterHandshake(ServerHttpRequest serverHttpRequest, ServerHttpResponse serverHttpResponse, WebSocketHandler webSocketHandler, Exception e) {

    }
}
