package com.factory.base.entity.aggregates;

import lombok.Getter;

@Getter
public enum ResponseEnum {

    OK("20000", "成功"),
    UN_AUTHENTICATION("40401", "未认证,请重新登陆"),
    AUTHENTICATION_EXPIRE("40402", "认证超时"),
    UNAUTHORIZED("40415", "未授权,无法完成操作"),
    NOTFOUND("40404", "未找到资源"),
    BAD_REQUEST("40400", "参数有误"),
    FAIL("50000", "服务异常"),
    USERNAME_NOT_FOND("40416", "用户名不存在"),
    USER_STOP("40417", "用户被禁用"),
    PASSWORD_FILE("40418", "密码错误"),
    USER_NOT_PERMISSION("40419", "无权登录");

    public final String status;
    public final String message;

    ResponseEnum(String status, String message) {
        this.status = status;
        this.message = message;
    }

}
