package com.factory.base.entity.po;

import com.baomidou.mybatisplus.annotation.*;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * @program: intelligent-factory-service
 * @description:
 * @author: dl
 * @create: 05月14日 08时
 **/
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BasePo2 implements Serializable {

    public final static String DEFAULT_USERNAME = "system";

    public final static Long DEFAULT_USER_ID = 1L;

    /**
     * 主键
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty("主键")
    public Long id;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "逻辑删除", hidden = true)
    public Integer deleted;
    /**
     * 创建人
     */
    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty("创建人")
    public Long createdUserId;
    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty("创建时间")
    public LocalDateTime createdTime;
    /**
     * 最近更新人
     */
    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty("最近更新人")
    public Long updatedUserId;
    /**
     * 最近更新时间
     */
    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty("最近更新时间")
    public LocalDateTime updatedTime;
    /**
     * 乐观锁
     */
    @Version
    @ApiModelProperty("乐观锁")
    public Integer versionLock;
}
