package com.factory.base.entity.po.benteler;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * Initial计划未响应信息
 *
 * @author dl
 * @date 2021-07-02 17:46:48
 */
@Data
@TableName("benteler_expected_response_plan")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class BentelerExpectedResponsePlan implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)

    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "计划id")
    private Long planId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间", hidden = true)
    private LocalDateTime createdTime;

    @ApiModelProperty(value = "最近更新时间")
    private LocalDateTime expiredTime;

    @ApiModelProperty(value = "状态:1未响应2已发送3已过期")
    private Integer expectedStatus;

    @ApiModelProperty(value = "频次:1、首件2、200件3、中断；1日2周3月")
    private Integer frequency;

    @ApiModelProperty(value = "处理人")
    private Integer handleUserId;

    @ApiModelProperty(value = "处理时间")
    private LocalDateTime handleTime;

}
