package com.factory.base.entity.po.benteler;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 首件异常统计
 *
 * @author dl
 * @date 2021-07-02 17:46:48
 */
@Data
@TableName("benteler_ini_abnormal")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class BentelerIniAbnormal implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)

    @ApiModelProperty(value = "主键")
    private Long id;

    @ApiModelProperty(value = "发生时间")
    private LocalDateTime openTime;

    @ApiModelProperty(value = "版本id")
    private Long versionId;

    @ApiModelProperty(value = "工作站id")
    private Long workstationId;

    @ApiModelProperty(value = "检查项id")
    private Long versionItem;

    @ApiModelProperty(value = "检查结果id")
    private Long checkResultId;

    @ApiModelProperty(value = "检查项日结果id")
    private Long checkItem;

    @ApiModelProperty(value = "0未解决 1已解决")
    private Boolean solveFlag;

    @ApiModelProperty(value = "1首件2二百件3中断")
    private Integer checkType;


}
