package com.factory.base.entity.po.benteler;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.Valid;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 记录检查结果 - 分类结果 - 单一检查项结果
 *
 * @author dl
 * @date 2021-06-29 14:31:47
 */
@Data
@TableName("benteler_ini_check_item")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class BentelerIniCheckItem implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)

    @ApiModelProperty(value = "主键")
    private Long id;


    @ApiModelProperty(value = "检查项id")
    private Long versionItemId;

    @ApiModelProperty(value = "问题数量")
    private Integer issueNum;

    @ApiModelProperty(value = "数据类型")
    private Integer dataType;

    @ApiModelProperty(value = "检查结果id")
    private Long checkResultId;

    @ApiModelProperty(value = "1首件2二百件3中断")
    private Integer checkType;

    @ApiModelProperty(name = "提交状态 0 未保存 1 保存 2提交")
    private Integer submitType;

    @ApiModelProperty(value = "订单号")
    private String orderId;

    @ApiModelProperty(value = "审核结果json")
    private String gread;


    @ApiModelProperty(value = "重检序号")
    private Integer repeat;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "逻辑删除", hidden = true)
    private Integer deleted;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建人", hidden = true)
    private Long createdUserId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间", hidden = true)
    private LocalDateTime createdTime;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新人", hidden = true)
    private Long updatedUserId;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新时间", hidden = true)
    private LocalDateTime updatedTime;

    @TableField(exist = false)
    @ApiModelProperty(value = "workId")
    private Long workId;

    @TableField(exist = false)
    @ApiModelProperty(value = "具体工位得分", hidden = true)
    private List<@Valid IniGread> iniGreads;
}
