package com.factory.base.entity.po.benteler;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 计划 - 首件/两百/中断  结果统计
 *
 * @author dl
 * @date 2021-06-29 14:31:47
 */
@Data
@TableName("benteler_ini_check_type")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class BentelerIniCheckType implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)

    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "检查记录id")
    private Long checkResultId;

    @ApiModelProperty(value = "1首件2二百件3中断")
    private Integer checkType;

    @ApiModelProperty(value = "提交人")
    private Long submitUser;

    @ApiModelProperty(value = "提交时间")
    private LocalDateTime submitTime;

    @ApiModelProperty(value = "1保存2提交")
    private Integer status;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "逻辑删除", hidden = true)
    private Integer deleted;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建人", hidden = true)
    private Long createdUserId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间", hidden = true)
    private LocalDateTime createdTime;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新人", hidden = true)
    private Long updatedUserId;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新时间", hidden = true)
    private LocalDateTime updatedTime;

}
