package com.factory.base.entity.po.benteler;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.util.List;

/**
 * 计划 - 版本信息
 *
 * @author dl
 * @date 2021-06-29 14:31:47
 */
@Data
@TableName("benteler_ini_version")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class BentelerIniVersion implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)

    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "计划id")
    private Long planId;

    @ApiModelProperty(value = "当前点检状态 1未完成 2已完成")
    private Integer checkStatus;

    @ApiModelProperty(value = "责任人1")
    private Long principleOne;

    @ApiModelProperty(value = "责任人2")
    private Long principleTwo;

    @ApiModelProperty(value = "检验开始时间")
    private LocalTime checkBegintime;

    @ApiModelProperty(value = "检验结束时间")
    private LocalTime checkEndtime;

    @ApiModelProperty(value = "提醒首件pad时长")
    private Integer remindIniPad;

    @ApiModelProperty(value = "提醒两百pad提交时刻")
    private LocalTime remindTwoPad;

    @ApiModelProperty(value = "升级提醒时间")
    private LocalTime upgradeTime;

    @ApiModelProperty(value = "生效日期")
    private LocalDate beginDate;

    @ApiModelProperty(value = "截止日期")
    private LocalDate endDate;

    @ApiModelProperty(value = "检查频率 所有子项汇总频率 首件/200/中断")
    private String allChecktype;

    @ApiModelProperty(value = "审核状态 1待审核 2当前版本 3历史版本 4驳回")
    private Integer reviewStatus;

    @ApiModelProperty(value = "基础信息")
    private String baseMap;

    @ApiModelProperty(value = "受控文件id")
    private Long controlledDocumentId;

    @ApiModelProperty(value = "指导文件id")
    private Long guideDocumentId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "逻辑删除", hidden = true)
    private Integer deleted;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建人", hidden = true)
    private Long createdUserId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间", hidden = true)
    private LocalDateTime createdTime;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新人", hidden = true)
    private Long updatedUserId;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新时间", hidden = true)
    private LocalDateTime updatedTime;


    @TableField(exist = false)
    @ApiModelProperty(value = "工作站")
    private List<BentelerIniWorkstation> workstations;
}
