package com.factory.base.entity.po.benteler;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.Valid;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.util.List;

/**
 * 计划 - 检查项
 *
 * @author dl
 * @date 2021-06-29 14:31:47
 */
@Data
@TableName("benteler_ini_version_item")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class BentelerIniVersionItem implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "计划ID")
    private Long planId;

    @ApiModelProperty(value = "工作站Id")
    private Long workstationId;

    @ApiModelProperty(value = "版本号id")
    private Long versionId;

    @ApiModelProperty(value = "检验开始时间")
    private LocalTime checkBegintime;

    @ApiModelProperty(value = "检验结束时间")
    private LocalTime checkEndtime;

    @ApiModelProperty(value = "提醒首件pad时长")
    private Integer remindIniPad;

    @ApiModelProperty(value = "提醒两百pad提交时刻")
    private LocalTime remindTwoPad;

    @ApiModelProperty(value = "升级提醒时间")
    private LocalTime upgradeTime;

    @ApiModelProperty(value = "频次1日2周3月4季度5半年6班")
    private Integer frequency;

    @ApiModelProperty(value = "频次检测点 第(5)天 星期(3)")
    private Integer frequencyNo;

    @ApiModelProperty(value = "频率1首件 2两百 3中断 包括哪项")
    private String checkType;


    @ApiModelProperty(value = "特性")
    private String inspectionItem;

    @ApiModelProperty(value = "测量点描述")
    private String measuRemark;

    @ApiModelProperty(value = "判断标准方法")
    private String method;

    @ApiModelProperty(value = "数据类别 0数值 1属性")
    private Integer dataType;

    @ApiModelProperty(value = "检测标准值上限")
    private BigDecimal checkStandardTop;

    @ApiModelProperty(value = "检测标准值下限")
    private BigDecimal checkStandardFloor;

    @ApiModelProperty(value = "特性等级")
    private String level;

    @ApiModelProperty(value = "单位")
    private String unit;

    @ApiModelProperty(value = "工位前缀")
    private String workPrefix;

    @ApiModelProperty(value = "检验测量点首号")
    private Integer workStationBegin;

    @ApiModelProperty(value = "检验测量点尾号")
    private Integer workStationEnd;


    @ApiModelProperty(value = "校验工具")
    private Integer tool;

    @ApiModelProperty(value = "校验工具 具体描述")
    private String toolRemark;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "逻辑删除", hidden = true)
    private Integer deleted;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建人", hidden = true)
    private Long createdUserId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间", hidden = true)
    private LocalDateTime createdTime;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新人", hidden = true)
    private Long updatedUserId;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新时间", hidden = true)
    private LocalDateTime updatedTime;


    @TableField(exist = false)
    @ApiModelProperty(value = "具体工位得分", hidden = true)
    private List<@Valid BentelerIniCheckItem> checkItems;


}
