package com.factory.base.entity.po.benteler;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 计划 - 问题记录表
 *
 * @author dl
 * @date 2021-07-02 17:46:47
 */
@Data
@TableName("benteler_issue")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class BentelerIssue implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)

    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "计划类型 1首件 2防错")
    private Integer checkType;

    @ApiModelProperty(value = "检测分项结果id")
    private Long checkSubId;

    @ApiModelProperty(value = "当前负责角色")
    private String principal;

    @ApiModelProperty(value = "是否放行0未放行1已放行2最终未放行")
    private Integer discharged;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "逻辑删除", hidden = true)
    private Integer deleted;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建人", hidden = true)
    private Long createdUserId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间", hidden = true)
    private LocalDateTime createdTime;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新人", hidden = true)
    private Long updatedUserId;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新时间", hidden = true)
    private LocalDateTime updatedTime;

    @ApiModelProperty(value = "乐观锁")
    private Integer versionLock;

}
