package com.factory.base.entity.po.benteler;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import springfox.documentation.spring.web.json.Json;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * Initial通知消息
 *
 * @author dl
 * @date 2021-07-02 17:46:48
 */
@Data
@TableName("benteler_message")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class BentelerMessage implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)

    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "消息接手人")
    private Long toUserId;

    @ApiModelProperty(value = "消息发送人")
    private Long fromUserId;

    @ApiModelProperty(value = "消息类型：1待响应计划通知2待审核计划通知3问题待审核通知")
    private Integer messageType;

    @ApiModelProperty(value = "状态:1未响应2已发送3已过期")
    private Integer sendStatus;

    @ApiModelProperty(value = "消息详情：json object")
    private Json messageContent;

    @ApiModelProperty(value = "消息标题")
    private String messageTitle;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间", hidden = true)
    private LocalDateTime createdTime;

    @ApiModelProperty(value = "预计发送时间")
    private LocalDateTime expectedTime;

}
