package com.factory.base.entity.po.benteler;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 版本 审核记录
 *
 * @author dl
 * @date 2021-06-29 19:22:36
 */
@Data
@TableName("benteler_version_audit")
@Builder
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude()
public class BentelerVersionAudit implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)

    @ApiModelProperty(value = "主键id")
    private Long id;

    @ApiModelProperty(value = "版本id")
    private Long versionId;

    @ApiModelProperty(value = "审核人id")
    private Long auditUserId;

    @ApiModelProperty(value = "角色id")
    private Integer roleId;

    @ApiModelProperty(value = "计划类型 1首件 2防错")
    private Integer checkType;

    @ApiModelProperty(value = "审核结果  1通过2驳回")
    private Integer auditResult;

    @ApiModelProperty(value = "审核备注")
    private String remark;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "逻辑删除", hidden = true)
    private Integer deleted;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建人", hidden = true)
    private Long createdUserId;

    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(value = "创建时间", hidden = true)
    private LocalDateTime createdTime;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新人", hidden = true)
    private String updatedUserId;

    @TableField(fill = FieldFill.UPDATE)
    @ApiModelProperty(value = "最近更新时间", hidden = true)
    private LocalDateTime updatedTime;

    @ApiModelProperty(value = "乐观锁")
    private Integer versionLock;

}
