package com.factory.base.entity.po.file;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.factory.base.entity.auth.FileType;
import com.factory.base.entity.po.BasePo;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author dingsong
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName(value = "file_info")
public class FileInfo extends BasePo {

    /**
     * 现名称
     */
    @TableField(value = "name")
    private String name;

    /**
     * 原名
     */
    @TableField(value = "original_name")
    private String originalName;

    /**
     * 后缀
     */
    @TableField(value = "suffix")
    private String suffix;

    /**
     * 访问后缀
     */
    @TableField(value = "uri")
    private String uri;

    /**
     * 大小
     */
    @TableField(value = "size")
    private Long size;

    /**
     * 磁盘路径
     */
    @TableField(value = "disk_path")
    private String diskPath;

    /**
     * 类型
     */
    @TableField(value = "type")
    private FileType type;

}
