package com.factory.base.entity.po.remote;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.factory.base.entity.constant.RemoteCommonConstants;
import com.factory.base.entity.po.BaseIdPo;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Objects;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName(value = "us_user")
public class UserInfo extends BaseIdPo implements Serializable {


    @TableField(value = "username")
    private String username;

    @TableField(value = "`password`")
    private String password;

    @TableField(value = "`lock`")
    private boolean lock;

    @TableField(value = "effective_time")
    private LocalDateTime effectiveTime;

    @TableField(value = "remark")
    private String remark;

    @TableField(value = "`no`")
    private String no;

    @TableField(value = "name")
    private String name;

    @TableField(value = "dept_id")
    private Long deptId;

    @TableField(value = "shift_id", updateStrategy = FieldStrategy.IGNORED)
    private Long shiftId;

    @TableField(value = "del_flag")
    private int deleted = RemoteCommonConstants.NOT_DEL;

    @TableField(value = "phone")
    private String phone;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        UserInfo userInfo = (UserInfo) o;
        return lock == userInfo.lock &&
                deleted == userInfo.deleted &&
                Objects.equals(username, userInfo.username) &&
                Objects.equals(password, userInfo.password) &&
                Objects.equals(effectiveTime, userInfo.effectiveTime) &&
                Objects.equals(remark, userInfo.remark) &&
                Objects.equals(no, userInfo.no) &&
                Objects.equals(name, userInfo.name) &&
                Objects.equals(deptId, userInfo.deptId) &&
                Objects.equals(shiftId, userInfo.shiftId);
    }

    @Override
    public int hashCode() {
        return Objects.hash(super.hashCode(), username, password, lock, effectiveTime, remark, no, name, deptId, shiftId, deleted);
    }
}
