package com.factory.base.entity.task;

import java.io.Serializable;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class FirstCalendar implements Serializable {

    @ApiModelProperty(value = "唯一id主键")
    private Long id;

    @ApiModelProperty(value = "关联benteler_plan表的id")
    private Long bentelerPlanId;

    @ApiModelProperty(value = "首件开始时间")
    private String firstStart;

    @ApiModelProperty(value = "首件提醒时间=首件开始时间+检验时长(分钟)")
    private String firstRemind;

    @ApiModelProperty(value = "首件（检测结束时间）")
    private String firstEnd;

    @ApiModelProperty(value = "200件提交时间（pad提醒时间）")
    private String twoRemind;

    @ApiModelProperty(value = "升级时长(分钟)")
    private Integer upleverTimeNum;

    @ApiModelProperty(value = "0:首件  1:200件  2:中断 判断该计划有几种类型")
    private String typeFlag;

    @ApiModelProperty(value = "责任人1班次")
    private String principalOneShift;

    @ApiModelProperty(value = "责任人1id")
    private Long principalOneId;

    @ApiModelProperty(value = "责任人2班次")
    private String principalTwoShift;

    @ApiModelProperty(value = "责任人2id")
    private Long principalTwoId;

    @ApiModelProperty(value = "任务创建时间")
    private String taskTime;

    @ApiModelProperty(value = "任务id")
    private Long firstTaskId;
}
