package com.factory.base.entity.vo.req;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.Min;

/**
 * @version 1.0
 * @Author mwh
 * @Date 2020/2/14 15:20
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BasePageReq {

    @ApiModelProperty("页码")
    @Min(value = 1, message = "页数最小值不能小于1")
    private int page = 1;
    @ApiModelProperty("每页数据大小")
    @Min(value = 1, message = "记录数不能小于1")
    private int size = 99999;


}
