package com.factory.base.util.assembler;

import com.factory.base.config.properties.FileSystemProperties;
import com.factory.base.entity.constant.SystemConstant;
import com.factory.base.entity.po.file.FileInfo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;

@Service
public class WebFileInfoAssembler {

    @Resource
    private FileSystemProperties fileSystemProperties;

    public String getUrlByFileInfo(FileInfo fileInfo) {
        if (fileInfo == null) {
            return SystemConstant.EMPTY_STRING;
        }
        if (StringUtils.isBlank(fileInfo.getUri())) {
            return SystemConstant.EMPTY_STRING;
        }
        return StringUtils.join(
                fileSystemProperties.getDownloadPrefix(),
                fileInfo.getUri()
        );
    }
}
