package com.factory.user.config;


import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

/**
 * @author mwh
 * description    登录设置项
 * createDate     2019/4/11 10:26
 * updateRemark
 * version        1.0
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Component
@ConfigurationProperties(prefix = "cn.jiheng.auth")
public class AuthenticationProperties {

    private String loginUrl = "https://s2.jihengcc.cn/web/login";

    private String headerName = "Authorization";

    private String client = "APP";

    private String defaultNickname;

    private List<String> permitUrlList = new ArrayList<>();

    private List<String> logIgnoreParamList = new ArrayList<>();
}
