package com.factory.user.controller;

import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.user.service.AuthService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * Controller to authenticate users.
 */
@RestController
@RequestMapping("/auth")
public class AuthController {

    @Resource
    private AuthService authService;


    @PostMapping("/refreshToken")
    public ResponseBean<String> refreshToken(String refreshToken) {
        return authService.refreshToken(refreshToken);
    }

}
