package com.factory.user.controller;

import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.user.entity.po.LoginPo;
import com.factory.user.entity.vo.LoginVo;
import com.factory.user.service.UsersService;
import com.factory.user.util.AopNotIntercept;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

@Api(tags = {"认证"})
@RestController
@AopNotIntercept()
public class AuthLoginController {

    @Autowired
    private UsersService usersService;

    @ApiOperation(value = "登录")
    @PostMapping("login")
    public ResponseBean<LoginVo> login(@RequestBody LoginPo po) {
        return this.usersService.login(po.getClient(), po.getUsername(), po.getPassword());
    }

}
