package com.factory.user.controller;

import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.entity.po.remote.Role;
import com.factory.base.util.res.ResponseBeanBuilder;
import com.factory.user.service.RoleService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * 角色
 *
 * @author sMArT
 * @version 1.0
 * @date 2021-07-05 11:26 下午
 */
@Api(tags = "用户管理")
@RestController
@RequestMapping("/role")
public class RoleController {
    @Resource
    RoleService roleService;

    @PostMapping("/list")
    @ApiOperation(value = "角色列表")
    public ResponseBean<List<Role>> list() {
        return ResponseBeanBuilder.ok(roleService.list());
    }
}
