package com.factory.user.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.factory.base.entity.po.remote.Role;
import com.factory.base.entity.po.remote.UserInfo;
import com.factory.user.entity.vo.UserVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Component;

import java.util.List;


@Component
@Mapper
public interface UsersMapper extends BaseMapper<UserInfo> {


    @Select("SELECT u.`*`,d.name AS deptName FROM us_user u  " +
            "LEFT JOIN us_dept d ON d.del_flag=0 AND d.id=u.dept_id " +
            "WHERE u.del_flag=0 AND u.username=#{username}")
    UserVo getUserByUsername(@Param("username") String username);

    @Select("SELECT u.`*`,d.name AS deptName FROM us_user u  " +
            "LEFT JOIN us_dept d ON d.del_flag=0 AND d.id=u.dept_id " +
            "WHERE u.del_flag=0 AND u.id=#{userId}")
    UserVo getUserById(@Param("userId") Long userId);

    @Select("SELECT distinct r.id,r.name FROM us_user u  " +
            " JOIN us_user_role ur ON u.id=ur.user_id " +
            " JOIN us_role r ON r.del_flag=0 AND r.id=ur.role_id " +
            "WHERE u.del_flag=0 AND u.id=#{userId}")
    List<Role> getUserRole(@Param("userId") Long userId);
}
