package com.factory.user.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.factory.base.entity.aggregates.PageBean;
import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.entity.po.remote.UserInfo;
import com.factory.user.entity.vo.req.UserInsertReq;
import com.factory.user.entity.vo.req.UserLockReq;
import com.factory.user.entity.vo.req.UserPageQueryReq;
import com.factory.user.entity.vo.res.UserRes;

import java.util.List;


public interface UserInfoService extends IService<UserInfo> {

    String getNameInfoById(Long id);

    List<UserInfo> getListByNameOrNo(String word);

    ResponseBean<PageBean<UserRes>> selectUser(UserPageQueryReq userPageQueryReq);

    ResponseBean<String> insertUser(UserInsertReq userInsertReq);

    ResponseBean<String> updateUser(UserInsertReq userInsertReq);

    ResponseBean<String> userLock(UserLockReq userLockReq);


    List<UserInfo> getUserByRole(List<Long> roleList);
}
