package com.factory.user.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.factory.base.entity.constant.SystemConstant;
import com.factory.base.entity.po.remote.UserInfo;
import com.factory.user.mapper.AuthUserInfoMapper;
import com.factory.user.service.AuthUserInfoService;
import org.springframework.stereotype.Service;

import java.util.List;


@Service
public class AuthUserInfoServiceImpl extends ServiceImpl<AuthUserInfoMapper, UserInfo> implements AuthUserInfoService {
    @Override
    public String getNameById(Long id) {
        String name = SystemConstant.EMPTY_STRING;
        if (id == null) {
            return name;
        }
        UserInfo userInfo = getById(id);
        if (userInfo != null) {
            name = userInfo.getName();
        }
        return name;
    }

    @Override
    public List<UserInfo> getListByNameOrNo(String word) {
        return list(Wrappers.<UserInfo>lambdaQuery().like(UserInfo::getName, word).or().like(UserInfo::getNo, word));
    }

}
