package com.factory.user.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.factory.base.entity.constant.SystemConstant;
import com.factory.base.entity.po.file.FileInfo;
import com.factory.user.mapper.FileInfoMapper;
import com.factory.user.service.FileInfoService;
import com.factory.user.util.FileInfoAssembler;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

/**
 * 考虑独立文件服务器 暂时采用多数据源读库 后续按需求修改
 */

@Service
@Transactional(propagation = Propagation.REQUIRES_NEW)
public class FileInfoServiceImpl extends ServiceImpl<FileInfoMapper, FileInfo> implements FileInfoService {

    @Resource
    private FileInfoAssembler fileInfoAssembler;

    @Override
    public String getUrlById(Long fileInfoId) {
        if (fileInfoId == null) {
            return SystemConstant.EMPTY_STRING;
        }
        FileInfo fileInfo = getById(fileInfoId);
        return fileInfoAssembler.getUrlByFileInfo(fileInfo);
    }

}
