package com.factory.user.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.factory.base.entity.po.remote.UserRole;
import com.factory.user.mapper.UserRoleMapper;
import com.factory.user.service.UserRoleService;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Service
public class UserRoleServiceImpl extends ServiceImpl<UserRoleMapper, UserRole> implements UserRoleService {

	@Override
	public boolean userHasRole(Long userId, Long roleId) {
		return getRoleIdsByUserId(userId).contains(roleId);
	}

	@Override
	public List<UserRole> getRolesByUserId(Long userId) {
		List<UserRole> userRoleList = list(Wrappers.<UserRole>lambdaQuery().eq(UserRole::getUserId, userId));
		return userRoleList;
	}

	@Override
	public List<Long> getRoleIdsByUserId(Long userId) {
		List<UserRole> userRoleList = getRolesByUserId(userId);
		List<Long> roleIds = userRoleList.stream().map(UserRole::getRoleId).collect(Collectors.toList());
		return roleIds;
	}

	@Override
	public List<Long> getUserIdsByRoleId(Long roleId) {
		return this.baseMapper.getUserIdsByRoleId(roleId);
	}

}
